class
	LIBMPZ_ASSEMBLER

feature {NONE}

	asm1 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm1 (op1.c_pointer, op2.c_pointer)
		end

	c_asm1 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * wp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" "L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " "L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (wp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = wp;
			]"
		end

	asm2 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32])
		do
			c_asm2 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm2 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * wp = *(unsigned long * *)$op2;
				long wsize = *(long *)$op3;

				__asm__ volatile ("\n" "L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " "L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___0)
						: "0" (wp + wsize)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = wp;
				*(long *)$op3 = wsize;
			]"
		end

	asm3 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm3 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm3 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long k0 = *(unsigned long *)$op1;
				unsigned long k1 = *(unsigned long *)$op2;
				unsigned long kacc = *(unsigned long *)$op3;
				unsigned long i = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (k0), "=d" (k1)
						: "%0" ((unsigned int)kacc), "rm" ((unsigned int)i)
					);

				*(unsigned long *)$op1 = k0;
				*(unsigned long *)$op2 = k1;
				*(unsigned long *)$op3 = kacc;
				*(unsigned long *)$op4 = i;
			]"
		end

	asm4 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm4 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm4 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long n0 = *(unsigned long *)$op1;
				unsigned long n1 = *(unsigned long *)$op2;
				unsigned long nacc = *(unsigned long *)$op3;
				unsigned long j = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (n0), "=d" (n1)
						: "%0" ((unsigned int)nacc), "rm" ((unsigned int)j)
					);

				*(unsigned long *)$op1 = n0;
				*(unsigned long *)$op2 = n1;
				*(unsigned long *)$op3 = nacc;
				*(unsigned long *)$op4 = j;
			]"
		end

	asm5 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm5 (op1.c_pointer, op2.c_pointer)
		end

	c_asm5 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" "L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " "L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm6 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm6 (op1.c_pointer, op2.c_pointer)
		end

	c_asm6 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" "L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " "L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm7 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm7 (op1.c_pointer, op2.c_pointer)
		end

	c_asm7 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * wp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" "L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " "L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (wp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = wp;
			]"
		end

	asm8 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm8 (op1.c_pointer, op2.c_pointer)
		end

	c_asm8 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * __dst___0 = *(unsigned long * *)$op1;
				unsigned long * __src___0 = *(unsigned long * *)$op2;

				__asm__ volatile ("bswap %0"
						: "=r" (*__dst___0)
						: "0" (*__src___0)
					);

				*(unsigned long * *)$op1 = __dst___0;
				*(unsigned long * *)$op2 = __src___0;
			]"
		end

	asm9 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm9 (op1.c_pointer, op2.c_pointer)
		end

	c_asm9 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * __dst___1 = *(unsigned long * *)$op1;
				unsigned long * __src___1 = *(unsigned long * *)$op2;

				__asm__ volatile ("bswap %0"
						: "=r" (*__dst___1)
						: "0" (*__src___1)
					);

				*(unsigned long * *)$op1 = __dst___1;
				*(unsigned long * *)$op2 = __src___1;
			]"
		end

	asm10 (op1: CE_ARRAY [CE_ARRAY [NATURAL_32]]; op2: CE_ARRAY [NATURAL_32])
		do
			c_asm10 (op1.c_pointer, op2.c_pointer)
		end

	c_asm10 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * d = (unsigned long *)$op1;
				unsigned long n = *(unsigned long *)$op2;

				__asm__ volatile ("mull %3"
						: "=a" (d[0]), "=d" (d[1])
						: "%0" ((unsigned int)n), "rm" ((unsigned int)3160155467ul)
					);

				*(unsigned long *)$op2 = n;
			]"
		end

	asm11 (op1: CE_ARRAY [CE_ARRAY [NATURAL_32]]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm11 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm11 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * d = (unsigned long *)$op1;
				unsigned long n = *(unsigned long *)$op2;
				unsigned long z = *(unsigned long *)$op3;

				__asm__ volatile ("mull %3"
						: "=a" (d[0]), "=d" (d[1])
						: "%0" ((unsigned int)n), "rm" ((unsigned int)z)
					);

				*(unsigned long *)$op2 = n;
				*(unsigned long *)$op3 = z;
			]"
		end

	asm12 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [INTEGER_32])
		do
			c_asm12 (op1.c_pointer, op2.c_pointer)
		end

	c_asm12 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long __dst = *(unsigned long *)$op1;
				long z = *(long *)$op2;

				__asm__ volatile ("bswap %0"
						: "=r" (__dst)
						: "0" (z)
					);

				*(unsigned long *)$op1 = __dst;
				*(long *)$op2 = z;
			]"
		end

	asm13 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm13 (op1.c_pointer, op2.c_pointer)
		end

	c_asm13 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" "L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " "L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm14 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm14 (op1.c_pointer, op2.c_pointer)
		end

	c_asm14 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" "L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " "L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm15 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm15 (op1.c_pointer, op2.c_pointer)
		end

	c_asm15 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * __dst = *(unsigned long * *)$op1;
				unsigned long * __src = *(unsigned long * *)$op2;

				__asm__ volatile ("bswap %0"
						: "=r" (*__dst)
						: "0" (*__src)
					);

				*(unsigned long * *)$op1 = __dst;
				*(unsigned long * *)$op2 = __src;
			]"
		end

	asm16 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm16 (op1.c_pointer, op2.c_pointer)
		end

	c_asm16 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long elimb = *(unsigned long *)$op1;
				unsigned long * ep = *(unsigned long * *)$op2;

				__asm__ volatile ("bswap %0"
						: "=r" (elimb)
						: "0" (*ep)
					);

				*(unsigned long *)$op1 = elimb;
				*(unsigned long * *)$op2 = ep;
			]"
		end

	asm17 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm17 (op1.c_pointer, op2.c_pointer)
		end

	c_asm17 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long slimb = *(unsigned long *)$op1;
				unsigned long * sp = *(unsigned long * *)$op2;

				__asm__ volatile ("bswap %0"
						: "=r" (slimb)
						: "0" (*sp)
					);

				*(unsigned long *)$op1 = slimb;
				*(unsigned long * *)$op2 = sp;
			]"
		end

	asm18 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm18 (op1.c_pointer, op2.c_pointer)
		end

	c_asm18 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * lp = *(unsigned long * *)$op2;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " "L" "asm_%=_" "done" "\n" "L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " "L" "asm_%=_" "top" "\n" "L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (lp), "ri" ((unsigned long)4l)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = lp;
			]"
		end

	asm19 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm19 (op1.c_pointer, op2.c_pointer)
		end

	c_asm19 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * xp = *(unsigned long * *)$op2;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " "L" "asm_%=_" "done" "\n" "L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " "L" "asm_%=_" "top" "\n" "L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (xp), "ri" ((unsigned long)2l)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = xp;
			]"
		end

	asm20 (op1: CE_ARRAY [INTEGER_8]; op2: CE_ARRAY [NATURAL_32])
		do
			c_asm20 (op1.c_pointer, op2.c_pointer)
		end

	c_asm20 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				char __p = *(char *)$op1;
				unsigned long __n___0 = *(unsigned long *)$op2;

				__asm__ volatile ("xorb %h1, %b1\n\t" "setpo %0"
						: "=Qm" (__p), "=Q" (__n___0)
						: "1" (__n___0)
					);

				*(char *)$op1 = __p;
				*(unsigned long *)$op2 = __n___0;
			]"
		end

	asm21 (op1: CE_ARRAY [CE_POINTER [INTEGER_8]]; op2: CE_ARRAY [NATURAL_32])
		do
			c_asm21 (op1.c_pointer, op2.c_pointer)
		end

	c_asm21 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				char * bp = *(char * *)$op1;
				unsigned long xlimb = *(unsigned long *)$op2;

				__asm__ volatile ("bswap %0"
						: "=r" (*((unsigned long *)bp))
						: "0" (xlimb)
					);

				*(char * *)$op1 = bp;
				*(unsigned long *)$op2 = xlimb;
			]"
		end

	asm22 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm22 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm22 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long p0 = *(unsigned long *)$op1;
				unsigned long p1 = *(unsigned long *)$op2;
				unsigned long p = *(unsigned long *)$op3;
				unsigned long q = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (p0), "=d" (p1)
						: "%0" ((unsigned int)p), "rm" ((unsigned int)q)
					);

				*(unsigned long *)$op1 = p0;
				*(unsigned long *)$op2 = p1;
				*(unsigned long *)$op3 = p;
				*(unsigned long *)$op4 = q;
			]"
		end

	asm23 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm23 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm23 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * rp = *(unsigned long * *)$op2;
				unsigned long bi = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " "L" "asm_%=_" "done" "\n" "L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " "L" "asm_%=_" "top" "\n" "L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (rp + bi / 32ul), "ri" (1ul << bi % 32ul)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = rp;
				*(unsigned long *)$op3 = bi;
			]"
		end

	asm24 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm24 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm24 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * dp = *(unsigned long * *)$op2;
				long limb_index = *(long *)$op3;
				unsigned long bit_index = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " "L" "asm_%=_" "done" "\n" "L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " "L" "asm_%=_" "top" "\n" "L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (dp + limb_index), "ri" (1ul << bit_index % 32ul)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = dp;
				*(long *)$op3 = limb_index;
				*(unsigned long *)$op4 = bit_index;
			]"
		end

end
