class
	P_AORS_UI_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_add_ui (a_w, a_u: CE_POINTER [PD_MPZ_STRUCT]; a_vval: NATURAL_32)
		local
			l_up: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_wsize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_cy: NATURAL_32
			l_return: BOOLEAN
		do
			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_abs_usize := l_usize
			else
				l_abs_usize := -l_usize
			end
			l_wsize := l_abs_usize + 1
			if (a_w.item.mp_alloc).to_integer_32 < l_wsize then
				(create {P_REALLOC_STATIC}).gmpz_realloc (a_w, l_wsize).do_nothing
			end
			l_up := a_u.item.mp_d
			l_wp := a_w.item.mp_d
			if l_abs_usize = 0 then
				l_wp[0] := a_vval
				a_w.item.mp_size := (a_vval /= {NATURAL_32} 0).to_integer
				l_return := True
			end
			if not l_return then
				if l_usize >= 0 then
					l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_wp, l_up, l_abs_usize, a_vval)
					l_wp[l_abs_usize] := l_cy
					l_wsize := (l_abs_usize.to_natural_32 + l_cy).to_integer_32
				elseif l_abs_usize = 1 then
					if l_up[0] < a_vval then
						l_wp[0] := a_vval - l_up[0]
						l_wsize := (1).to_integer_32
					else
						(create {P_GMP_STATIC}).gmpn_sub_1 (l_wp, l_up, l_abs_usize, a_vval).do_nothing
						l_wsize := -(l_abs_usize - (l_wp[(l_abs_usize - 1)] = {NATURAL_32} 0).to_integer)
					end
				else
					(create {P_GMP_STATIC}).gmpn_sub_1 (l_wp, l_up, l_abs_usize, a_vval).do_nothing
					l_wsize := -(l_abs_usize - (l_wp[(l_abs_usize - 1)] = {NATURAL_32} 0).to_integer)
				end
				a_w.item.mp_size := l_wsize.to_integer_32
			end
		end

	gmpz_sub_ui (a_w, a_u: CE_POINTER [PD_MPZ_STRUCT]; a_vval: NATURAL_32)
		local
			l_up: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_wsize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_cy: NATURAL_32
			l_return: BOOLEAN
		do
			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_abs_usize := l_usize
			else
				l_abs_usize := -l_usize
			end
			l_wsize := l_abs_usize + 1
			if (a_w.item.mp_alloc).to_integer_32 < l_wsize then
				(create {P_REALLOC_STATIC}).gmpz_realloc (a_w, l_wsize).do_nothing
			end
			l_up := a_u.item.mp_d
			l_wp := a_w.item.mp_d
			if l_abs_usize = 0 then
				l_wp[0] := a_vval
				a_w.item.mp_size := (-(a_vval /= {NATURAL_32} 0).to_integer).to_integer
				l_return := True
			end
			if not l_return then
				if l_usize < 0 then
					l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_wp, l_up, l_abs_usize, a_vval)
					l_wp[l_abs_usize] := l_cy
					l_wsize := ((-(l_abs_usize.to_natural_32 + l_cy).to_integer_32).to_natural_32).to_integer_32
				elseif l_abs_usize = 1 then
					if l_up[0] < a_vval then
						l_wp[0] := a_vval - l_up[0]
						l_wsize := (-1).to_integer_32
					else
						(create {P_GMP_STATIC}).gmpn_sub_1 (l_wp, l_up, l_abs_usize, a_vval).do_nothing
						l_wsize := l_abs_usize - (l_wp[(l_abs_usize - 1)] = {NATURAL_32} 0).to_integer
					end
				else
					(create {P_GMP_STATIC}).gmpn_sub_1 (l_wp, l_up, l_abs_usize, a_vval).do_nothing
					l_wsize := l_abs_usize - (l_wp[(l_abs_usize - 1)] = {NATURAL_32} 0).to_integer
				end
				a_w.item.mp_size := l_wsize.to_integer_32
			end
		end

end
