class
	P_CONG_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_congruent_p (a_a, a_c, a_d: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_a: CE_POINTER [PD_MPZ_STRUCT]
			l_c: CE_POINTER [PD_MPZ_STRUCT]
			l_asize: INTEGER_32
			l_csize: INTEGER_32
			l_dsize: INTEGER_32
			l_sign: INTEGER_32
			l_ap: CE_POINTER [NATURAL_32]
			l_cp: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_xp: CE_POINTER [NATURAL_32]
			l_alow: NATURAL_32
			l_clow: NATURAL_32
			l_dlow: NATURAL_32
			l_dmask: NATURAL_32
			l_r: NATURAL_32
			l_result: INTEGER_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_mpz_srcptr_swap_tmp: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp_1: INTEGER_32
			l_tmp_2: INTEGER_32
			l_twos: NATURAL_32
			l_dnorm: NATURAL_32
			l_tmp_5: NATURAL_32
			l_twos2: NATURAL_32
			l_tmp_7: INTEGER_32
			l_dsecond: NATURAL_32
			l_twos_0: NATURAL_32
			l_tmp_12: CE_POINTER [ANY]
			l_carry: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a := a_a
					l_c := a_c
					l_dsize := (a_d.item.mp_size).to_integer_32
					if (builtin_expect ((l_dsize = 0).to_integer, 0)).to_boolean then
						Result := (((create {P_CMP_STATIC}).gmpz_cmp (l_a, l_c)) = 0).to_integer
						l_return := True
					end
					if not l_return then
						if l_dsize >= 0 then
							l_dsize := l_dsize
						else
							l_dsize := -l_dsize
						end
						l_dp := a_d.item.mp_d
						if l_a.item.mp_size >= 0 then
							l_tmp_1 := l_a.item.mp_size
						else
							l_tmp_1 := -l_a.item.mp_size
						end
						if l_c.item.mp_size >= 0 then
							l_tmp_2 := l_c.item.mp_size
						else
							l_tmp_2 := -l_c.item.mp_size
						end
						if l_tmp_1 < l_tmp_2 then
							from
							until
								(l_break)
							loop
								l_break := False
								l_mpz_srcptr_swap_tmp := l_a
								l_a := l_c
								l_c := l_mpz_srcptr_swap_tmp
								l_break := True
							end
							l_break := False
						end
						l_asize := (l_a.item.mp_size).to_integer_32
						l_csize := (l_c.item.mp_size).to_integer_32
						l_sign := (l_asize).bit_xor (l_csize)
						if l_asize >= 0 then
							l_asize := l_asize
						else
							l_asize := -l_asize
						end
						l_ap := l_a.item.mp_d
						if l_csize = 0 then
							Result := ((create {P_GMP_IMPL_STATIC}).gmpn_divisible_p (l_ap, l_asize, l_dp, l_dsize))
							l_return := True
						end
					end
					if not l_return then
						if l_csize >= 0 then
							l_csize := l_csize
						else
							l_csize := -l_csize
						end
						l_cp := l_c.item.mp_d
						l_alow := l_ap[0]
						l_clow := l_cp[0]
						l_dlow := l_dp[0]
						l_dmask := ((((l_dlow).bit_and ((-l_dlow.to_integer_32).to_natural_32)) - {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
						if l_sign >= 0 then
							l_alow := l_alow
						else
							l_alow := (-l_alow.to_integer_32).to_natural_32
						end
						if (((l_alow - l_clow)).bit_and (l_dmask)) /= {NATURAL_32} 0 then
							Result := 0
							l_return := True
						end
					end
					if not (not l_return and then (l_csize = 1)) then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if l_dsize /= 1 then
							l_pos := -1 + 3 -- skip if block
						end
				when 2 then -- if: | cong_1:
						if l_sign < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_clow <= l_dlow then
									l_clow := l_dlow - l_clow
								else
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										l_twos := (builtin_clzl (l_dlow)).to_natural_32
										l_break := True
									end
									l_break := False
									l_twos := l_twos
									l_dnorm := (l_dlow).bit_shift_left (l_twos.to_integer_32)
									if l_clow <= l_dnorm then
										l_tmp_5 := l_dnorm
									else
										l_tmp_5 := {NATURAL_32} 2 * l_dnorm
									end
									l_clow := l_tmp_5 - l_clow
								end
								l_break := True
							end
							l_break := False
						end
						if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_asize >= 22 then
								l_r := (create {P_GMP_STATIC}).gmpn_mod_1 (l_ap, l_asize, l_dlow)
								if l_clow < l_dlow then
									Result := (l_r = l_clow).to_integer
									l_return := True
								else
									Result := (l_r = l_clow \\ l_dlow).to_integer
									l_return := True
								end
							end
						end
						if not l_return then
							if ((l_dlow).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_twos2 := (builtin_ctzl (l_dlow)).to_natural_32
									l_break := True
								end
								l_break := False
								l_dlow := (l_dlow).bit_shift_right (l_twos2.to_integer_32)
							end
							l_r := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1c_odd (l_ap, l_asize, l_dlow, l_clow)
							if l_r = {NATURAL_32} 0 then
								l_tmp_7 := 1
							elseif l_r = l_dlow then
								l_tmp_7 := 1
							else
								l_tmp_7 := 0
							end
							Result := l_tmp_7
							l_return := True
						end
				when 3 then -- if done
						if not l_return and then (l_dsize = 2) then
							if l_dlow /= {NATURAL_32} 0 then
								l_dsecond := l_dp[1]
								if l_dsecond <= l_dmask then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										l_twos_0 := (builtin_ctzl (l_dlow)).to_natural_32
										l_break := True
									end
									l_break := False
									l_dlow := (((l_dlow).bit_shift_right (l_twos_0.to_integer_32))).bit_or (((l_dsecond).bit_shift_left (({NATURAL_32} 32 - l_twos_0).to_integer_32)))
									l_pos := -1 + 2 -- goto cong_1
								end
							end
						end
				when 4 then
					if not l_return then
						l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						if (builtin_expect (((l_asize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp_12 := (l_aaf.new (((l_asize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp_12 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_asize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_xp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_12)
						if l_sign >= 0 then
							if l_asize > l_csize then
								(create {P_GMP_STATIC}).gmpn_sub (l_xp, l_ap, l_asize, l_cp, l_csize).do_nothing
							elseif ((create {P_GMP_STATIC}).gmpn_cmp (l_ap, l_cp, l_asize)) >= 0 then
								(create {P_GMP_STATIC}).gmpn_sub (l_xp, l_ap, l_asize, l_cp, l_csize).do_nothing
							else
								(create {P_GMP_STATIC}).gmpn_sub_n (l_xp, l_cp, l_ap, l_asize).do_nothing
							end
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									not (not (l_break) and then (l_asize > 0))
								loop
									l_break := False
									if l_xp[(l_asize - 1)] /= {NATURAL_32} 0 then
										l_break := True
									end
									if not (l_return or l_break) then
										l_asize := l_asize - 1
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
						else
							l_carry := (create {P_GMP_STATIC}).gmpn_add (l_xp, l_ap, l_asize, l_cp, l_csize)
							l_xp[l_asize] := l_carry
							l_asize := l_asize + (l_carry /= {NATURAL_32} 0).to_integer
						end
						l_result := (create {P_GMP_IMPL_STATIC}).gmpn_divisible_p (l_xp, l_asize, l_dp, l_dsize)
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
						Result := l_result
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
