class
	P_DIVE_UI_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_divexact_ui (a_dst, a_src: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32)
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_dst_ptr: CE_POINTER [NATURAL_32]
			l_dlimbs: CE_ARRAY [NATURAL_32]
			l_dz: CE_ARRAY [PD_MPZ_STRUCT]
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_dlimbs.make (<<2>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_dz.make (<<1>>)

			if a_divisor = {NATURAL_32} 0 then
				(create {P_GMP_IMPL_STATIC}).gmp_divide_by_zero
			end
			if a_divisor > {NATURAL_32} 4_294_967_295 then
				l_dz[0].mp_alloc := 2
				l_dz[0].mp_d := l_dlimbs;
				(create {P_SET_UI_STATIC}).gmpz_set_ui (l_dz, a_divisor);
				(create {P_DIVEXACT_STATIC}).gmpz_divexact (a_dst, a_src, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_dz))
				l_return := True
			end
			if not l_return then
				l_size := (a_src.item.mp_size).to_integer_32
				if l_size = 0 then
					a_dst.item.mp_size := 0
					l_return := True
				end
			end
			if not l_return then
				if l_size >= 0 then
					l_abs_size := l_size
				else
					l_abs_size := -l_size
				end
				if (builtin_expect ((l_abs_size > (a_dst.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_dst, l_abs_size).do_nothing
				end
				l_dst_ptr := a_dst.item.mp_d
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_IMPL_STATIC}).gmpn_divexact_1 (l_dst_ptr, a_src.item.mp_d, l_abs_size, a_divisor)
					l_break := True
				end
				l_break := False
				l_abs_size := l_abs_size - (l_dst_ptr[(l_abs_size - 1)] = {NATURAL_32} 0).to_integer
				if l_size >= 0 then
					a_dst.item.mp_size := l_abs_size.to_integer_32
				else
					a_dst.item.mp_size := (-l_abs_size).to_integer_32
				end
			end
		end

end
