class
	P_FITS_S_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_fits_sint_p (a_z: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_n: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_limb: NATURAL_32
			l_return: BOOLEAN
		do
			l_n := (a_z.item.mp_size).to_integer_32
			l_p := a_z.item.mp_d
			l_limb := l_p[0]
			if l_n = 0 then
				Result := 1
				l_return := True
			end
			if not l_return and then (l_n = 1) then
				Result := (l_limb <= (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_natural_32).to_integer
				l_return := True
			end
			if not l_return and then (l_n = -1) then
				Result := (l_limb <= (-(((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32).to_natural_32).to_integer_32).to_natural_32).to_integer
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	gmpz_fits_slong_p (a_z: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_n: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_limb: NATURAL_32
			l_return: BOOLEAN
		do
			l_n := (a_z.item.mp_size).to_integer_32
			l_p := a_z.item.mp_d
			l_limb := l_p[0]
			if l_n = 0 then
				Result := 1
				l_return := True
			end
			if not l_return and then (l_n = 1) then
				Result := (l_limb <= (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_natural_32).to_integer
				l_return := True
			end
			if not l_return and then (l_n = -1) then
				Result := (l_limb <= (-(((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32).to_natural_32).to_integer_32).to_natural_32).to_integer
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	gmpz_fits_sshort_p (a_z: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_n: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_limb: NATURAL_32
			l_return: BOOLEAN
		do
			l_n := (a_z.item.mp_size).to_integer_32
			l_p := a_z.item.mp_d
			l_limb := l_p[0]
			if l_n = 0 then
				Result := 1
				l_return := True
			end
			if not l_return and then (l_n = 1) then
				Result := (l_limb <= ((-(((((65_535).bit_xor (((65_535).bit_shift_right (1)))).to_natural_16).to_integer_16).to_integer_32 + 1)).to_integer_16).to_natural_32).to_integer
				l_return := True
			end
			if not l_return and then (l_n = -1) then
				Result := (l_limb <= (-(((((65_535).bit_xor (((65_535).bit_shift_right (1)))).to_natural_16).to_integer_16).to_natural_32).to_integer_32).to_natural_32).to_integer
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

end
