class
	P_GMP_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpq_set (a_arg1, a_arg2: CE_POINTER [PD_MPQ_STRUCT])
		do
			c_gmpq_set (a_arg1.c_pointer, a_arg2.c_pointer)
		end

	c_gmpq_set (a_arg1: POINTER; a_arg2: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmpq_set($a_arg1, $a_arg2);"
		end

	gmpn_add_n (a_arg1, a_arg2, a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_add_n (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4)
		end

	c_gmpn_add_n (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: INTEGER_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_add_n($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_perfect_square_p (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32): INTEGER_32
		do
			Result := c_gmpn_perfect_square_p (a_arg1.c_pointer, a_arg2)
		end

	c_gmpn_perfect_square_p (a_arg1: POINTER; a_arg2: INTEGER_32): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_perfect_square_p($a_arg1, $a_arg2);"
		end

	gmpn_popcount (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_popcount (a_arg1.c_pointer, a_arg2)
		end

	c_gmpn_popcount (a_arg1: POINTER; a_arg2: INTEGER_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_popcount($a_arg1, $a_arg2);"
		end

	gmpn_sub_n (a_arg1, a_arg2, a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_sub_n (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4)
		end

	c_gmpn_sub_n (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: INTEGER_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_sub_n($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpz_fits_uint_p (a_gmp_z: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_gmp_n: INTEGER_32
			l_gmp_p: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
		do
			l_gmp_n := (a_gmp_z.item.mp_size).to_integer_32
			l_gmp_p := a_gmp_z.item.mp_d
			if l_gmp_n = 0 then
				l_tmp := 1
			elseif l_gmp_n = 1 then
				if l_gmp_p[0] <= {NATURAL_32} 4_294_967_295 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	gmpz_fits_ushort_p (a_gmp_z: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_gmp_n: INTEGER_32
			l_gmp_p: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
		do
			l_gmp_n := (a_gmp_z.item.mp_size).to_integer_32
			l_gmp_p := a_gmp_z.item.mp_d
			if l_gmp_n = 0 then
				l_tmp := 1
			elseif l_gmp_n = 1 then
				if l_gmp_p[0] <= {NATURAL_32} 65_535 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	gmpz_get_ui (a_gmp_z: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l_gmp_p: CE_POINTER [NATURAL_32]
			l_gmp_n: INTEGER_32
			l_gmp_l: NATURAL_32
			l_tmp: NATURAL_32
		do
			l_gmp_p := a_gmp_z.item.mp_d
			l_gmp_n := (a_gmp_z.item.mp_size).to_integer_32
			l_gmp_l := l_gmp_p[0]
			if l_gmp_n /= 0 then
				l_tmp := l_gmp_l
			else
				l_tmp := (0).to_natural_32
			end
			Result := l_tmp
		end

	gmpz_getlimbn (a_gmp_z: CE_POINTER [PD_MPZ_STRUCT]; a_gmp_n: INTEGER_32): NATURAL_32
		local
			l_gmp_result: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp_0: INTEGER_32
		do
			l_gmp_result := (0).to_natural_32
			if a_gmp_n >= 0 then
				if a_gmp_z.item.mp_size >= 0 then
					l_tmp := a_gmp_z.item.mp_size
				else
					l_tmp := -a_gmp_z.item.mp_size
				end
				if a_gmp_n < l_tmp.to_integer_32 then
					l_tmp_0 := 1
				else
					l_tmp_0 := 0
				end
			else
				l_tmp_0 := 0
			end
			if (builtin_expect ((l_tmp_0 /= 0).to_integer, 1)).to_boolean then
				l_gmp_result := a_gmp_z.item.mp_d[a_gmp_n]
			end
			Result := l_gmp_result
		end

	gmpz_perfect_square_p (a_gmp_a: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_gmp_asize: INTEGER_32
			l_gmp_result: INTEGER_32
		do
			l_gmp_asize := (a_gmp_a.item.mp_size).to_integer_32
			l_gmp_result := (l_gmp_asize >= 0).to_integer
			if (builtin_expect ((l_gmp_asize > 0).to_integer, 1)).to_boolean then
				l_gmp_result := gmpn_perfect_square_p (a_gmp_a.item.mp_d, l_gmp_asize)
			end
			Result := l_gmp_result
		end

	gmpz_popcount (a_gmp_u: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l_gmp_usize: INTEGER_32
			l_gmp_result: NATURAL_32
		do
			l_gmp_usize := (a_gmp_u.item.mp_size).to_integer_32
			if l_gmp_usize < 0 then
				l_gmp_result := ({NATURAL_32} 0).bit_not
			else
				l_gmp_result := (0).to_natural_32
			end
			if (builtin_expect ((l_gmp_usize > 0).to_integer, 1)).to_boolean then
				l_gmp_result := gmpn_popcount (a_gmp_u.item.mp_d, l_gmp_usize)
			end
			Result := l_gmp_result
		end

	gmpz_set_q (a_gmp_w: CE_POINTER [PD_MPZ_STRUCT]; a_gmp_u: CE_POINTER [PD_MPQ_STRUCT])
		do
			(create {P_TDIV_Q_STATIC}).gmpz_tdiv_q (a_gmp_w, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_gmp_u.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_gmp_u.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
		end

	gmpz_size (a_gmp_z: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l_tmp: INTEGER_32
		do
			if a_gmp_z.item.mp_size >= 0 then
				l_tmp := a_gmp_z.item.mp_size
			else
				l_tmp := -a_gmp_z.item.mp_size
			end
			Result := l_tmp.to_natural_32
		end

	gmpq_abs (a_gmp_w, a_gmp_u: CE_POINTER [PD_MPQ_STRUCT])
		do
			if not a_gmp_w.is_equal (a_gmp_u) then
				gmpq_set (a_gmp_w, a_gmp_u)
			end
			if a_gmp_w.item.mp_num.mp_size >= 0 then
				a_gmp_w.item.mp_num.mp_size := a_gmp_w.item.mp_num.mp_size
			else
				a_gmp_w.item.mp_num.mp_size := -a_gmp_w.item.mp_num.mp_size
			end
		end

	gmpq_neg (a_gmp_w, a_gmp_u: CE_POINTER [PD_MPQ_STRUCT])
		do
			if not a_gmp_w.is_equal (a_gmp_u) then
				gmpq_set (a_gmp_w, a_gmp_u)
			end
			a_gmp_w.item.mp_num.mp_size := -a_gmp_w.item.mp_num.mp_size
		end

	gmpn_add (a_gmp_wp, a_gmp_xp: CE_POINTER [NATURAL_32]; a_gmp_xsize: INTEGER_32; a_gmp_yp: CE_POINTER [NATURAL_32]; a_gmp_ysize: INTEGER_32): NATURAL_32
		local
			l_gmp_c: NATURAL_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp_0: NATURAL_32
			l_gmp_j: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (l_return or l_break) then
						l_pos := -1 + 9 -- skip loop
					end
				when 1 then -- loop body:
						l_break := False
						l_gmp_i := a_gmp_ysize
						if l_gmp_i = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not ((gmpn_add_n (a_gmp_wp, a_gmp_xp, a_gmp_yp, l_gmp_i)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						if l_gmp_i >= a_gmp_xsize then
							l_gmp_c := (1).to_natural_32
							l_pos := -1 + 8 -- goto __gmp_done
						end
				when 5 then
						l_gmp_x := a_gmp_xp[l_gmp_i]
						l_tmp := l_gmp_i
						l_gmp_i := l_gmp_i + 1
						l_tmp_0 := ((l_gmp_x + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
						a_gmp_wp[l_tmp] := l_tmp_0
						if l_tmp_0 /= {NATURAL_32} 0 then
							l_break := True
						end
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						l_break := False
				when 7 then -- if done | if done
						if not a_gmp_wp.is_equal (a_gmp_xp) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_gmp_j := l_gmp_i
								from
								until
									not (l_gmp_j < a_gmp_xsize)
								loop
									a_gmp_wp[l_gmp_j] := a_gmp_xp[l_gmp_j]
									l_gmp_j := l_gmp_j + 1
								end
								l_break := True
							end
							l_break := False
						end
						l_gmp_c := (0).to_natural_32
				when 8 then -- __gmp_done:
						
						l_break := True
						l_pos := -1 + 0 -- back to loop condition
				when 9 then -- loop done
					l_break := False
					Result := l_gmp_c
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_add_1 (a_gmp_dst, a_gmp_src: CE_POINTER [NATURAL_32]; a_gmp_size: INTEGER_32; a_gmp_n: NATURAL_32): NATURAL_32
		local
			l_gmp_c: NATURAL_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_r: NATURAL_32
			l_gmp_j: INTEGER_32
			l_gmp_j_0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_gmp_x := a_gmp_src[0]
				l_gmp_r := l_gmp_x + a_gmp_n
				a_gmp_dst[0] := l_gmp_r
				if l_gmp_r < a_gmp_n then
					l_gmp_c := (1).to_natural_32
					l_gmp_i := (1).to_integer_32
					from
					until
						not (not (l_return or l_break) and then (l_gmp_i < a_gmp_size))
					loop
						l_break := False
						l_gmp_x := a_gmp_src[l_gmp_i]
						l_gmp_r := l_gmp_x + {NATURAL_32} 1
						a_gmp_dst[l_gmp_i] := l_gmp_r
						l_gmp_i := l_gmp_i + 1
						if not (l_gmp_r < {NATURAL_32} 1) then
							if not a_gmp_src.is_equal (a_gmp_dst) then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_gmp_j := l_gmp_i
									from
									until
										not (l_gmp_j < a_gmp_size)
									loop
										a_gmp_dst[l_gmp_j] := a_gmp_src[l_gmp_j]
										l_gmp_j := l_gmp_j + 1
									end
									l_break := True
								end
								l_break := False
							end
							l_gmp_c := (0).to_natural_32
							l_break := True
						end
					end
					l_break := False
				else
					if not a_gmp_src.is_equal (a_gmp_dst) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_gmp_j_0 := (1).to_integer_32
							from
							until
								not (l_gmp_j_0 < a_gmp_size)
							loop
								a_gmp_dst[l_gmp_j_0] := a_gmp_src[l_gmp_j_0]
								l_gmp_j_0 := l_gmp_j_0 + 1
							end
							l_break := True
						end
						l_break := False
					end
					l_gmp_c := (0).to_natural_32
				end
				l_break := True
			end
			l_break := False
			Result := l_gmp_c
		end

	gmpn_cmp (a_gmp_xp, a_gmp_yp: CE_POINTER [NATURAL_32]; a_gmp_size: INTEGER_32): INTEGER_32
		local
			l_gmp_result: INTEGER_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_y: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_gmp_result := 0
				l_gmp_i := a_gmp_size
				from
				until
					(l_break)
				loop
					l_break := False
					l_gmp_i := l_gmp_i - 1
					if not (l_gmp_i >= 0) then
						l_break := True
					end
					if not (l_break) then
						l_gmp_x := a_gmp_xp[l_gmp_i]
						l_gmp_y := a_gmp_yp[l_gmp_i]
						if l_gmp_x /= l_gmp_y then
							if l_gmp_x > l_gmp_y then
								l_gmp_result := 1
							else
								l_gmp_result := -1
							end
							l_break := True
						end
					end
				end
				l_break := False
				l_break := True
			end
			l_break := False
			Result := l_gmp_result
		end

	gmpn_sub (a_gmp_wp, a_gmp_xp: CE_POINTER [NATURAL_32]; a_gmp_xsize: INTEGER_32; a_gmp_yp: CE_POINTER [NATURAL_32]; a_gmp_ysize: INTEGER_32): NATURAL_32
		local
			l_gmp_c: NATURAL_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_tmp: INTEGER_32
			l_gmp_j: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (l_return or l_break) then
						l_pos := -1 + 9 -- skip loop
					end
				when 1 then -- loop body:
						l_break := False
						l_gmp_i := a_gmp_ysize
						if l_gmp_i = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not ((gmpn_sub_n (a_gmp_wp, a_gmp_xp, a_gmp_yp, l_gmp_i)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						if l_gmp_i >= a_gmp_xsize then
							l_gmp_c := (1).to_natural_32
							l_pos := -1 + 8 -- goto __gmp_done
						end
				when 5 then
						l_gmp_x := a_gmp_xp[l_gmp_i]
						l_tmp := l_gmp_i
						l_gmp_i := l_gmp_i + 1
						a_gmp_wp[l_tmp] := ((l_gmp_x - {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
						if l_gmp_x /= {NATURAL_32} 0 then
							l_break := True
						end
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						l_break := False
				when 7 then -- if done | if done
						if not a_gmp_wp.is_equal (a_gmp_xp) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_gmp_j := l_gmp_i
								from
								until
									not (l_gmp_j < a_gmp_xsize)
								loop
									a_gmp_wp[l_gmp_j] := a_gmp_xp[l_gmp_j]
									l_gmp_j := l_gmp_j + 1
								end
								l_break := True
							end
							l_break := False
						end
						l_gmp_c := (0).to_natural_32
				when 8 then -- __gmp_done:
						
						l_break := True
						l_pos := -1 + 0 -- back to loop condition
				when 9 then -- loop done
					l_break := False
					Result := l_gmp_c
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_sub_1 (a_gmp_dst, a_gmp_src: CE_POINTER [NATURAL_32]; a_gmp_size: INTEGER_32; a_gmp_n: NATURAL_32): NATURAL_32
		local
			l_gmp_c: NATURAL_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_r: NATURAL_32
			l_gmp_j: INTEGER_32
			l_gmp_j_0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_gmp_x := a_gmp_src[0]
				l_gmp_r := l_gmp_x - a_gmp_n
				a_gmp_dst[0] := l_gmp_r
				if l_gmp_x < a_gmp_n then
					l_gmp_c := (1).to_natural_32
					l_gmp_i := (1).to_integer_32
					from
					until
						not (not (l_return or l_break) and then (l_gmp_i < a_gmp_size))
					loop
						l_break := False
						l_gmp_x := a_gmp_src[l_gmp_i]
						l_gmp_r := l_gmp_x - {NATURAL_32} 1
						a_gmp_dst[l_gmp_i] := l_gmp_r
						l_gmp_i := l_gmp_i + 1
						if not (l_gmp_x < {NATURAL_32} 1) then
							if not a_gmp_src.is_equal (a_gmp_dst) then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_gmp_j := l_gmp_i
									from
									until
										not (l_gmp_j < a_gmp_size)
									loop
										a_gmp_dst[l_gmp_j] := a_gmp_src[l_gmp_j]
										l_gmp_j := l_gmp_j + 1
									end
									l_break := True
								end
								l_break := False
							end
							l_gmp_c := (0).to_natural_32
							l_break := True
						end
					end
					l_break := False
				else
					if not a_gmp_src.is_equal (a_gmp_dst) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_gmp_j_0 := (1).to_integer_32
							from
							until
								not (l_gmp_j_0 < a_gmp_size)
							loop
								a_gmp_dst[l_gmp_j_0] := a_gmp_src[l_gmp_j_0]
								l_gmp_j_0 := l_gmp_j_0 + 1
							end
							l_break := True
						end
						l_break := False
					end
					l_gmp_c := (0).to_natural_32
				end
				l_break := True
			end
			l_break := False
			Result := l_gmp_c
		end

	gmpn_neg (a_gmp_rp, a_gmp_up: CE_POINTER [NATURAL_32]; a_gmp_n: INTEGER_32): NATURAL_32
		local
			l_gmp_rp: CE_POINTER [NATURAL_32]
			l_gmp_up: CE_POINTER [NATURAL_32]
			l_gmp_n: INTEGER_32
			l_gmp_ul: NATURAL_32
			l_gmp_cy: NATURAL_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp_0: CE_POINTER [NATURAL_32]
			l_break: BOOLEAN
		do
			l_gmp_rp := a_gmp_rp
			l_gmp_up := a_gmp_up
			l_gmp_n := a_gmp_n
			l_gmp_cy := (0).to_natural_32
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp := l_gmp_up
				l_gmp_up := l_gmp_up + 1
				l_gmp_ul := l_tmp.item
				l_tmp_0 := l_gmp_rp
				l_gmp_rp := l_gmp_rp + 1
				l_tmp_0.item := (-l_gmp_ul.to_integer_32).to_natural_32 - l_gmp_cy
				l_gmp_cy := (l_gmp_cy).bit_or ((l_gmp_ul /= {NATURAL_32} 0).to_integer.to_natural_32)
				l_gmp_n := l_gmp_n - 1
				if l_gmp_n = 0 then
					l_break := True
				end
			end
			l_break := False
			Result := l_gmp_cy
		end

	gmpn_copyi (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32)
		do
			c_gmpn_copyi (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_gmpn_copyi (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmpn_copyi($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_mul (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: CE_POINTER [NATURAL_32]; a_arg5: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_mul (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4.c_pointer, a_arg5)
		end

	c_gmpn_mul (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: POINTER; a_arg5: INTEGER_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_mul($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	gmpn_addmul_1 (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_addmul_1 (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_addmul_1 (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_addmul_1($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_mul_1 (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_mul_1 (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_mul_1 (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_mul_1($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_submul_1 (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_submul_1 (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_submul_1 (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_submul_1($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_divrem_1 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32; a_arg5: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_divrem_1 (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4, a_arg5)
		end

	c_gmpn_divrem_1 (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER; a_arg4: INTEGER_32; a_arg5: NATURAL_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_divrem_1($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	gmpn_mod_1 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_mod_1 (a_arg1.c_pointer, a_arg2, a_arg3)
		end

	c_gmpn_mod_1 (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: NATURAL_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_mod_1($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_rshift (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_rshift (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_rshift (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_rshift($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_lshift (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_lshift (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_lshift (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_lshift($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_gcd (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: CE_POINTER [NATURAL_32]; a_arg5: INTEGER_32): INTEGER_32
		do
			Result := c_gmpn_gcd (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4.c_pointer, a_arg5)
		end

	c_gmpn_gcd (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: POINTER; a_arg5: INTEGER_32): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_gcd($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	gmpn_gcd_1 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_gcd_1 (a_arg1.c_pointer, a_arg2, a_arg3)
		end

	c_gmpn_gcd_1 (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: NATURAL_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_gcd_1($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_gcdext (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: CE_POINTER [INTEGER_32]; a_arg4: CE_POINTER [NATURAL_32]; a_arg5: INTEGER_32; a_arg6: CE_POINTER [NATURAL_32]; a_arg7: INTEGER_32): INTEGER_32
		do
			Result := c_gmpn_gcdext (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4.c_pointer, a_arg5, a_arg6.c_pointer, a_arg7)
		end

	c_gmpn_gcdext (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: POINTER; a_arg5: INTEGER_32; a_arg6: POINTER; a_arg7: INTEGER_32): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_gcdext($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7);"
		end

	gmpn_get_str (a_arg1: CE_POINTER [NATURAL_8]; a_arg2: INTEGER_32; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_get_str (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4)
		end

	c_gmpn_get_str (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER; a_arg4: INTEGER_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_get_str($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_hamdist (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_hamdist (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_gmpn_hamdist (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_hamdist($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_set_str (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_8]; a_arg3: NATURAL_32; a_arg4: INTEGER_32): INTEGER_32
		do
			Result := c_gmpn_set_str (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_set_str (a_arg1: POINTER; a_arg2: POINTER; a_arg3: NATURAL_32; a_arg4: INTEGER_32): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_set_str($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_tdiv_qr (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: CE_POINTER [NATURAL_32]; a_arg5: INTEGER_32; a_arg6: CE_POINTER [NATURAL_32]; a_arg7: INTEGER_32)
		do
			c_gmpn_tdiv_qr (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4.c_pointer, a_arg5, a_arg6.c_pointer, a_arg7)
		end

	c_gmpn_tdiv_qr (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: POINTER; a_arg5: INTEGER_32; a_arg6: POINTER; a_arg7: INTEGER_32)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmpn_tdiv_qr($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7);"
		end

	gmpn_sqr (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32)
		do
			c_gmpn_sqr (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_gmpn_sqr (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmpn_sqr($a_arg1, $a_arg2, $a_arg3);"
		end

	gmp_randinit_default (a_arg1: CE_POINTER [PD_GMP_RANDSTATE_STRUCT])
		do
			c_gmp_randinit_default (a_arg1.c_pointer)
		end

	c_gmp_randinit_default (a_arg1: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmp_randinit_default($a_arg1);"
		end

	gmp_randclear (a_arg1: CE_POINTER [PD_GMP_RANDSTATE_STRUCT])
		do
			c_gmp_randclear (a_arg1.c_pointer)
		end

	c_gmp_randclear (a_arg1: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmp_randclear($a_arg1);"
		end

	gmpn_copyd (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32)
		do
			c_gmpn_copyd (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_gmpn_copyd (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmpn_copyd($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_perfect_power_p (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32): INTEGER_32
		do
			Result := c_gmpn_perfect_power_p (a_arg1.c_pointer, a_arg2)
		end

	c_gmpn_perfect_power_p (a_arg1: POINTER; a_arg2: INTEGER_32): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_perfect_power_p($a_arg1, $a_arg2);"
		end

	gmpn_preinv_mod_1 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3, a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_preinv_mod_1 (a_arg1.c_pointer, a_arg2, a_arg3, a_arg4)
		end

	c_gmpn_preinv_mod_1 (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: NATURAL_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_preinv_mod_1($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_random2 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32)
		do
			c_gmpn_random2 (a_arg1.c_pointer, a_arg2)
		end

	c_gmpn_random2 (a_arg1: POINTER; a_arg2: INTEGER_32)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmpn_random2($a_arg1, $a_arg2);"
		end

	gmpn_sqrtrem (a_arg1, a_arg2, a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32): INTEGER_32
		do
			Result := c_gmpn_sqrtrem (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4)
		end

	c_gmpn_sqrtrem (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: INTEGER_32): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_sqrtrem($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

end
