class
	P_HAMDIST_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_hamdist (a_u, a_v: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_count: NATURAL_32
			l_mp_srcptr_swap_tmp: CE_POINTER [NATURAL_32]
			l_mp_size_t_swap_tmp: INTEGER_32
			l_ulimb: NATURAL_32
			l_vlimb: NATURAL_32
			l_old_vsize: INTEGER_32
			l_step: INTEGER_32
			l_tmp_0: CE_POINTER [NATURAL_32]
			l_tmp_1: CE_POINTER [NATURAL_32]
			l_mp_srcptr_swap_tmp_0: CE_POINTER [NATURAL_32]
			l_mp_size_t_swap_tmp_0: INTEGER_32
			l_x: NATURAL_32
			l_twoscount: NATURAL_32
			l_tmp_2: CE_POINTER [NATURAL_32]
			l_tmp_4: CE_POINTER [NATURAL_32]
			l_x_0: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_usize := (a_u.item.mp_size).to_integer_32
					l_vsize := (a_v.item.mp_size).to_integer_32
					l_up := a_u.item.mp_d
					l_vp := a_v.item.mp_d
					if not (l_usize >= 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_vsize < 0 then
							Result := (((0).to_natural_32).bit_not)
							l_return := True
						end
						if not l_return then
							if l_usize < l_vsize then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_break)
									loop
										l_break := False
										l_mp_srcptr_swap_tmp := l_up
										l_up := l_vp
										l_vp := l_mp_srcptr_swap_tmp
										l_break := True
									end
									l_break := False
									from
									until
										(l_break)
									loop
										l_break := False
										l_mp_size_t_swap_tmp := l_usize
										l_usize := l_vsize
										l_vsize := l_mp_size_t_swap_tmp
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
							end
							l_count := (0).to_natural_32
							if l_vsize /= 0 then
								l_count := (create {P_GMP_STATIC}).gmpn_hamdist (l_up, l_vp, l_vsize)
							end
							l_usize := l_usize - l_vsize
							if l_usize /= 0 then
								l_count := l_count + ((create {P_GMP_STATIC}).gmpn_popcount (l_up + l_vsize, l_usize))
							end
							Result := l_count
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 3 then -- else:
						if l_vsize >= 0 then
							Result := (((0).to_natural_32).bit_not)
							l_return := True
						end
						if l_return then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						l_usize := -l_usize
						l_vsize := -l_vsize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_usize := l_usize - 1
							l_vsize := l_vsize - 1
							l_tmp_0 := l_up
							l_up := l_up + 1
							l_ulimb := l_tmp_0.item
							l_tmp_1 := l_vp
							l_vp := l_vp + 1
							l_vlimb := l_tmp_1.item
							if l_ulimb /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_return or l_break) and then (l_vlimb /= {NATURAL_32} 0) then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_break)
									loop
										l_break := False
										l_mp_srcptr_swap_tmp_0 := l_up
										l_up := l_vp
										l_vp := l_mp_srcptr_swap_tmp_0
										l_break := True
									end
									l_break := False
									from
									until
										(l_break)
									loop
										l_break := False
										l_mp_size_t_swap_tmp_0 := l_usize
										l_usize := l_vsize
										l_vsize := l_mp_size_t_swap_tmp_0
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								l_ulimb := l_vlimb
								l_vlimb := (0).to_natural_32
								l_break := True
							end
						end
						l_break := False
						l_ulimb := (-l_ulimb.to_integer_32).to_natural_32
						l_vlimb := (-l_vlimb.to_integer_32).to_natural_32
						from
						until
							(l_break)
						loop
							l_break := False
							l_x := (((l_ulimb).bit_xor (l_vlimb))).bit_and ({NATURAL_32} 4_294_967_295)
							l_x := l_x - ((((l_x).bit_shift_right (1))).bit_and ({NATURAL_32} 1_431_655_765))
							l_x := ((((l_x).bit_shift_right (2))).bit_and ({NATURAL_32} 858_993_459)) + ((l_x).bit_and ({NATURAL_32} 858_993_459))
							l_x := ((((l_x).bit_shift_right (4)) + l_x)).bit_and ({NATURAL_32} 252_645_135)
							l_x := ((l_x).bit_shift_right (8)) + l_x
							l_x := ((l_x).bit_shift_right (16)) + l_x
							l_count := (l_x).bit_and ({NATURAL_32} 255)
							l_break := True
						end
						l_break := False
						if l_vlimb = {NATURAL_32} 0 then
							l_old_vsize := l_vsize
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_vsize := l_vsize - 1
								l_tmp_2 := l_vp
								l_vp := l_vp + 1
								l_vlimb := l_tmp_2.item
								if l_vlimb /= {NATURAL_32} 0 then
									l_break := True
								end
							end
							l_break := False
							l_step := (l_old_vsize - l_vsize) - 1
							l_count := l_count + (l_step * 32).to_natural_32
							if l_step < l_usize then
								l_step := l_step
							else
								l_step := l_usize
							end
							if l_step /= 0 then
								l_count := l_count - ((create {P_GMP_STATIC}).gmpn_popcount (l_up, l_step))
								l_usize := l_usize - l_step
								l_up := l_up + l_step
							end
							l_vlimb := l_vlimb - 1
							if l_usize /= 0 then
								l_usize := l_usize - 1
								l_tmp_4 := l_up
								l_up := l_up + 1
								l_vlimb := (l_vlimb).bit_xor ((l_tmp_4.item))
							end
							from
							until
								(l_break)
							loop
								l_break := False
								l_x_0 := l_vlimb
								l_x_0 := l_x_0 - ((((l_x_0).bit_shift_right (1))).bit_and ({NATURAL_32} 1_431_655_765))
								l_x_0 := ((((l_x_0).bit_shift_right (2))).bit_and ({NATURAL_32} 858_993_459)) + ((l_x_0).bit_and ({NATURAL_32} 858_993_459))
								l_x_0 := ((((l_x_0).bit_shift_right (4)) + l_x_0)).bit_and ({NATURAL_32} 252_645_135)
								l_x_0 := ((l_x_0).bit_shift_right (8)) + l_x_0
								l_x_0 := ((l_x_0).bit_shift_right (16)) + l_x_0
								l_twoscount := (l_x_0).bit_and ({NATURAL_32} 255)
								l_break := True
							end
							l_break := False
							l_count := l_count + l_twoscount
						end
						if l_usize < l_vsize then
							l_step := l_usize
						else
							l_step := l_vsize
						end
						if l_step /= 0 then
							l_count := l_count + ((create {P_GMP_STATIC}).gmpn_hamdist (l_up, l_vp, l_step))
							l_usize := l_usize - l_step
							l_vsize := l_vsize - l_step
							l_up := l_up + l_step
							l_vp := l_vp + l_step
						end
						if l_usize = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | remaining:
						l_count := l_count + ((create {P_GMP_STATIC}).gmpn_popcount (l_up, l_usize))
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						if l_vsize /= 0 then
							l_up := l_vp
							l_usize := l_vsize
							l_pos := -1 + 5 -- goto remaining
						end
				when 8 then
						Result := l_count
				when 9 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
