class
	P_IMPORT_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBMPZ_ASSEMBLER

feature {ANY} -- public routines

	gmpz_import (a_z: CE_POINTER [PD_MPZ_STRUCT]; a_count: NATURAL_32; a_order: INTEGER_32; a_size: NATURAL_32; a_endian: INTEGER_32; a_nail: NATURAL_32; a_data: CE_POINTER [ANY])
		local
			l_endian: INTEGER_32
			l_zsize: INTEGER_32
			l_zp: CE_POINTER [NATURAL_32]
			l_align: NATURAL_32
			l_dst: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_src: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_size: INTEGER_32
			l_i: INTEGER_32
			l_dst_0: CE_POINTER [NATURAL_32]
			l_size_0: INTEGER_32
			l_src_0: CE_POINTER [NATURAL_32]
			l_i_0: INTEGER_32
			l_limb: NATURAL_32
			l_byte: NATURAL_32
			l_wbitsmask: NATURAL_32
			l_i2: NATURAL_32
			l_j: NATURAL_32
			l_numb: NATURAL_32
			l_wbytes: NATURAL_32
			l_woffset: INTEGER_32
			l_dp: CE_POINTER [NATURAL_8]
			l_lbits: INTEGER_32
			l_wbits: INTEGER_32
			l_tmp_0: INTEGER_32
			l_tmp_1: NATURAL_32
			l_tmp_2: NATURAL_32
			l_tmp_3: NATURAL_32
			l_tmp_4: CE_POINTER [NATURAL_32]
			l_tmp_5: CE_POINTER [NATURAL_32]
			l_tmp_6: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_dst.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_src.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_endian := a_endian
					l_zsize := (((a_count * ({NATURAL_32} 8 * a_size - a_nail) + {NATURAL_32} 32) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
					if (builtin_expect ((l_zsize > (a_z.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						(create {P_REALLOC_STATIC}).gmpz_realloc (a_z, l_zsize).do_nothing
					end
					l_zp := a_z.item.mp_d
					if l_endian = 0 then
						l_endian := -1
					end
					if a_nail /= {NATURAL_32} 0 then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						l_align := ((create {CE_INTEGER_8_POINTER}.make_cast (a_data)).distance ((create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)))).to_natural_32 \\ {PLATFORM}.Natural_32_bytes.to_natural_32
						if a_order = -1 then
							if a_size = {PLATFORM}.Natural_32_bytes.to_natural_32 then
								if l_endian = -1 then
									if l_align = {NATURAL_32} 0 then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											from
											until
												(l_return or l_break)
											loop
												l_break := False;
												(create {P_GMP_STATIC}).gmpn_copyi (l_zp, create {CE_NATURAL_32_POINTER}.make_cast (a_data), a_count.to_integer_32)
												l_break := True
											end
											l_break := False
											l_break := True
										end
										l_break := False
										l_pos := -1 + 5 -- goto done
									end
								end
							end
						end
				when 2 then
						if a_order = -1 then
							if a_size = {PLATFORM}.Natural_32_bytes.to_natural_32 then
								if l_endian = 1 then
									if l_align = {NATURAL_32} 0 then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											l_dst.item := l_zp
											l_src.item := create {CE_NATURAL_32_POINTER}.make_cast (a_data)
											l_size := a_count.to_integer_32
											l_i := (0).to_integer_32
											from
											until
												not (not (l_return) and then (l_i < l_size))
											loop
												from
												until
													(l_break)
												loop
													l_break := False
													asm15 (l_dst, l_src)
													l_break := True
												end
												l_break := False
												l_dst.item := l_dst.item + 1
												l_src.item := l_src.item + 1
												l_i := l_i + 1
											end
											l_break := True
										end
										l_break := False
										l_pos := -1 + 5 -- goto done
									end
								end
							end
						end
				when 3 then
						if a_order = 1 then
							if a_size = {PLATFORM}.Natural_32_bytes.to_natural_32 then
								if l_endian = -1 then
									if l_align = {NATURAL_32} 0 then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											l_dst_0 := l_zp
											l_size_0 := a_count.to_integer_32
											l_src_0 := (create {CE_NATURAL_32_POINTER}.make_cast (a_data) + l_size_0) - 1
											l_i_0 := (0).to_integer_32
											from
											until
												not (l_i_0 < l_size_0)
											loop
												l_dst_0.item := l_src_0.item
												l_dst_0 := l_dst_0 + 1
												l_src_0 := l_src_0 - 1
												l_i_0 := l_i_0 + 1
											end
											l_break := True
										end
										l_break := False
										l_pos := -1 + 5 -- goto done
									end
								end
							end
						end
				when 4 then
					l_numb := a_size * {NATURAL_32} 8 - a_nail
					l_wbytes := l_numb // {NATURAL_32} 8
					l_wbits := (l_numb \\ {NATURAL_32} 8).to_integer_32
					l_wbitsmask := (({NATURAL_32} 1).bit_shift_left (l_wbits)) - {NATURAL_32} 1
					l_woffset := ((l_numb + {NATURAL_32} 7) // {NATURAL_32} 8).to_integer_32
					if l_endian >= 0 then
						l_tmp_0 := l_woffset
					else
						l_tmp_0 := -l_woffset
					end
					if a_order < 0 then
						l_tmp_1 := a_size.to_natural_32
					else
						l_tmp_1 := (-a_size.to_integer_32).to_natural_32
					end
					l_woffset := (l_tmp_0.to_natural_32 + l_tmp_1).to_integer_32
					if a_order >= 0 then
						l_tmp_2 := (a_count - {NATURAL_32} 1) * a_size
					else
						l_tmp_2 := (0).to_natural_32
					end
					if l_endian >= 0 then
						l_tmp_3 := a_size - {NATURAL_32} 1
					else
						l_tmp_3 := (0).to_natural_32
					end
					l_dp := (create {CE_NATURAL_8_POINTER}.make_cast (a_data) + l_tmp_2.to_integer_32) + l_tmp_3.to_integer_32
					l_limb := (0).to_natural_32
					l_lbits := 0
					l_i2 := (0).to_natural_32
					from
					until
						not (not (l_return) and then (l_i2 < a_count))
					loop
						l_j := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_j < l_wbytes))
						loop
							l_byte := (l_dp.item).to_natural_32
							l_dp := l_dp - l_endian
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_limb := (l_limb).bit_or (((l_byte).bit_shift_left (l_lbits)))
								l_lbits := l_lbits + (8)
								if l_lbits >= 32 then
									l_tmp_4 := l_zp
									l_zp := l_zp + 1
									l_tmp_4.item := (l_limb).bit_and ({NATURAL_32} 4_294_967_295)
									l_lbits := l_lbits - (32)
									l_limb := (l_byte).bit_shift_right ((8 - l_lbits))
								end
								l_break := True
							end
							l_break := False
							l_j := l_j + 1
						end
						if l_wbits /= 0 then
							l_byte := ((l_dp.item).to_natural_32).bit_and (l_wbitsmask)
							l_dp := l_dp - l_endian
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_limb := (l_limb).bit_or (((l_byte).bit_shift_left (l_lbits)))
								l_lbits := l_lbits + l_wbits
								if l_lbits >= 32 then
									l_tmp_5 := l_zp
									l_zp := l_zp + 1
									l_tmp_5.item := (l_limb).bit_and ({NATURAL_32} 4_294_967_295)
									l_lbits := l_lbits - (32)
									l_limb := (l_byte).bit_shift_right ((l_wbits - l_lbits))
								end
								l_break := True
							end
							l_break := False
						end
						l_dp := l_dp + l_woffset
						l_i2 := l_i2 + 1
					end
					if l_lbits /= 0 then
						l_tmp_6 := l_zp
						l_zp := l_zp + 1
						l_tmp_6.item := l_limb
					end
				when 5 then -- done:
					l_zp := a_z.item.mp_d
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_zsize > 0))
						loop
							l_break := False
							if l_zp[(l_zsize - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_zsize := l_zsize - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					a_z.item.mp_size := l_zsize.to_integer_32
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
