class
	P_INP_STR_STATIC

inherit
	CE_UTILITIES
	S_STDIO_STATIC
	S_CTYPE_STATIC
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public attributes

	gmp_digit_value_tab: CE_ARRAY [NATURAL_8] assign set_gmp_digit_value_tab
		do
			create {CE_NATURAL_8_ARRAY} Result.make_shared_from_pointer (c_gmp_digit_value_tab)
		end

	c_gmp_digit_value_tab: POINTER
		external
			"C inline use <libmpz.h>"
		alias
			"return (EIF_POINTER)__gmp_digit_value_tab;"
		end

	set_gmp_digit_value_tab (a_gmp_digit_value_tab: CE_ARRAY [NATURAL_8])
		do
			c_set_gmp_digit_value_tab (a_gmp_digit_value_tab.c_pointer)
		end

	c_set_gmp_digit_value_tab (a_gmp_digit_value_tab: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"printf(%"NATIVE_FUNCTIONS_WRITER.write_native_variable: AST_ARRAY_TYPE\n%");"
		end

feature {ANY} -- public routines

	gmpz_inp_str (a_x: CE_POINTER [PD_MPZ_STRUCT]; a_stream: CE_POINTER [SD_IO_FILE]; a_base: INTEGER_32): NATURAL_32
		local
			l_stream: CE_POINTER [SD_IO_FILE]
			l_c: INTEGER_32
			l_nread: NATURAL_32
			l_break: BOOLEAN
		do
			l_stream := a_stream
			if l_stream.is_void then
				l_stream := ce_input_file_pointer
			end
			l_nread := (0).to_natural_32
			from
			until
				(l_break)
			loop
				l_break := False
				l_c := getc (l_stream)
				l_nread := l_nread + 1
				if not isspace (l_c).to_boolean then
					l_break := True
				end
			end
			l_break := False
			Result := (gmpz_inp_str_nowhite (a_x, l_stream, a_base, l_c, l_nread))
		end

	gmpz_inp_str_nowhite (a_x: CE_POINTER [PD_MPZ_STRUCT]; a_stream: CE_POINTER [SD_IO_FILE]; a_base, a_c: INTEGER_32; a_nread: NATURAL_32): NATURAL_32
		local
			l_base: INTEGER_32
			l_c: INTEGER_32
			l_nread: NATURAL_32
			l_str: CE_POINTER [INTEGER_8]
			l_alloc_size: NATURAL_32
			l_str_size: NATURAL_32
			l_negative: INTEGER_32
			l_xsize: INTEGER_32
			l_digit_value: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_dig: INTEGER_32
			l_old_alloc_size: NATURAL_32
			l_tmp_2: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_base := a_base
			l_c := a_c
			l_nread := a_nread
			l_digit_value := gmp_digit_value_tab
			if l_base > 36 then
				l_digit_value := l_digit_value + (224)
				if l_base > 62 then
					Result := (0).to_natural_32
					l_return := True
				end
			end
			if not l_return then
				l_negative := 0
				if l_c = 45 then
					l_negative := 1
					l_c := getc (a_stream)
					l_nread := l_nread + 1
				end
				if l_c = -1 then
					Result := (0).to_natural_32
					l_return := True
				else
					if l_base = 0 then
						l_tmp := 10
					else
						l_tmp := l_base
					end
					if (l_digit_value[l_c]).to_integer_32 >= l_tmp then
						Result := (0).to_natural_32
						l_return := True
					end
				end
			end
			if not l_return then
				if l_base = 0 then
					l_base := 10
					if l_c = 48 then
						l_base := 8
						l_c := getc (a_stream)
						l_nread := l_nread + 1
						if l_c = 120 then
							l_base := 16
							l_c := getc (a_stream)
							l_nread := l_nread + 1
						elseif l_c = 88 then
							l_base := 16
							l_c := getc (a_stream)
							l_nread := l_nread + 1
						elseif l_c = 98 then
							l_base := 2
							l_c := getc (a_stream)
							l_nread := l_nread + 1
						elseif l_c = 66 then
							l_base := 2
							l_c := getc (a_stream)
							l_nread := l_nread + 1
						end
					end
				end
				from
				until
					l_c /= 48
				loop
					l_c := getc (a_stream)
					l_nread := l_nread + 1
				end
				l_alloc_size := (100).to_natural_32
				l_str := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_GMP_IMPL_STATIC}).gmp_allocate_func.pointer_item ([l_alloc_size]))))
				l_str_size := (0).to_natural_32
				from
				until
					not (not (l_break) and then (l_c /= -1))
				loop
					l_break := False
					l_dig := (l_digit_value[l_c]).to_integer_32
					if l_dig >= l_base then
						l_break := True
					end
					if not (l_break) then
						if l_str_size >= l_alloc_size then
							l_old_alloc_size := l_alloc_size
							l_alloc_size := (l_alloc_size * {NATURAL_32} 3) // {NATURAL_32} 2
							l_str := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_GMP_IMPL_STATIC}).gmp_reallocate_func.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_str), l_old_alloc_size, l_alloc_size]))))
						end
						l_tmp_2 := l_str_size
						l_str_size := l_str_size + 1
						l_str[l_tmp_2.to_integer_32] := l_dig.to_integer_8
						l_c := getc (a_stream)
					end
				end
				l_break := False
				l_nread := l_nread + l_str_size
				ungetc (l_c, a_stream).do_nothing
				l_nread := l_nread - 1
				if l_str_size = {NATURAL_32} 0 then
					a_x.item.mp_size := 0
				else
					l_xsize := 2 + (l_str_size.to_real_64 / ((32).to_double * (create {P_GMP_IMPL_STATIC}).gmpn_bases[l_base].chars_per_bit_exactly)).truncated_to_integer
					if (builtin_expect ((l_xsize > (a_x.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						(create {P_REALLOC_STATIC}).gmpz_realloc (a_x, l_xsize).do_nothing
					end
					l_xsize := (create {P_GMP_STATIC}).gmpn_set_str (a_x.item.mp_d, create {CE_NATURAL_8_POINTER}.make_cast (l_str), l_str_size, l_base)
					if l_negative.to_boolean then
						a_x.item.mp_size := (-l_xsize).to_integer_32
					else
						a_x.item.mp_size := l_xsize.to_integer_32
					end
				end
				(create {P_GMP_IMPL_STATIC}).gmp_free_func.call ([create {CE_VOID_POINTER}.make_cast (l_str), l_alloc_size])
				Result := l_nread
			end
		end

end
