class
	P_IOR_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_ior (a_res, a_op1, a_op2: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_op1: CE_POINTER [PD_MPZ_STRUCT]
			l_op2: CE_POINTER [PD_MPZ_STRUCT]
			l_op1_ptr: CE_POINTER [NATURAL_32]
			l_op2_ptr: CE_POINTER [NATURAL_32]
			l_op1_size: INTEGER_32
			l_op2_size: INTEGER_32
			l_res_ptr: CE_POINTER [NATURAL_32]
			l_res_size: INTEGER_32
			l_i: INTEGER_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_opx: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			l_tmp_2: CE_POINTER [ANY]
			l_tmp_7: CE_POINTER [ANY]
			l_mpz_srcptr_swap_tmp: CE_POINTER [PD_MPZ_STRUCT]
			l_mp_srcptr_swap_tmp: CE_POINTER [NATURAL_32]
			l_mp_size_t_swap_tmp: INTEGER_32
			l_opx_0: CE_POINTER [NATURAL_32]
			l_cy_0: NATURAL_32
			l_res_alloc: INTEGER_32
			l_count: INTEGER_32
			l_tmp_13: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			l_op1 := a_op1
			l_op2 := a_op2
			l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			l_op1_size := (l_op1.item.mp_size).to_integer_32
			l_op2_size := (l_op2.item.mp_size).to_integer_32
			l_op1_ptr := l_op1.item.mp_d
			l_op2_ptr := l_op2.item.mp_d
			l_res_ptr := a_res.item.mp_d
			if l_op1_size >= 0 then
				if l_op2_size >= 0 then
					if l_op1_size >= l_op2_size then
						if (a_res.item.mp_alloc).to_integer_32 < l_op1_size then
							(create {P_REALLOC_STATIC}).gmpz_realloc (a_res, l_op1_size).do_nothing
							l_op2_ptr := l_op2.item.mp_d
							l_res_ptr := a_res.item.mp_d
						end
						if not l_res_ptr.is_equal (l_op1_ptr) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_res_ptr + l_op2_size, l_op1_ptr + l_op2_size, l_op1_size - l_op2_size)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
						l_i := l_op2_size - 1
						from
						until
							not (l_i >= 0)
						loop
							l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_or (l_op2_ptr[l_i]))
							l_i := l_i - 1
						end
						l_res_size := l_op1_size
					else
						if (a_res.item.mp_alloc).to_integer_32 < l_op2_size then
							(create {P_REALLOC_STATIC}).gmpz_realloc (a_res, l_op2_size).do_nothing
							l_op1_ptr := l_op1.item.mp_d
							l_res_ptr := a_res.item.mp_d
						end
						if not l_res_ptr.is_equal (l_op2_ptr) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_res_ptr + l_op1_size, l_op2_ptr + l_op1_size, l_op2_size - l_op1_size)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
						l_i := l_op1_size - 1
						from
						until
							not (l_i >= 0)
						loop
							l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_or (l_op2_ptr[l_i]))
							l_i := l_i - 1
						end
						l_res_size := l_op2_size
					end
					a_res.item.mp_size := l_res_size.to_integer_32
					l_return := True
				end
			elseif l_op2_size < 0 then
				l_op1_size := -l_op1_size
				l_op2_size := -l_op2_size
				if l_op1_size < l_op2_size then
					l_res_size := l_op1_size
				else
					l_res_size := l_op2_size
				end
				if (builtin_expect ((l_res_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp_2 := (l_aaf.new ((l_res_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp_2 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_res_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_opx := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_2);
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_opx, l_op1_ptr, l_res_size, (1).to_natural_32).do_nothing
				l_op1_ptr := l_opx
				if (builtin_expect ((l_res_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp_7 := (l_aaf.new ((l_res_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp_7 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_res_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_opx := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_7);
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_opx, l_op2_ptr, l_res_size, (1).to_natural_32).do_nothing
				l_op2_ptr := l_opx
				if (a_res.item.mp_alloc).to_integer_32 < l_res_size then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_res, l_res_size).do_nothing
					l_res_ptr := a_res.item.mp_d
				end
				l_i := l_res_size - 1
				from
				until
					not (not (l_break) and then (l_i >= 0))
				loop
					l_break := False
					if ((l_op1_ptr[l_i]).bit_and (l_op2_ptr[l_i])) /= {NATURAL_32} 0 then
						l_break := True
					end
					if not (l_return or l_break) then
						l_i := l_i - 1
					end
				end
				l_break := False
				l_res_size := l_i + 1
				if l_res_size /= 0 then
					l_i := l_res_size - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_and (l_op2_ptr[l_i]))
						l_i := l_i - 1
					end
					l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_res_ptr, l_res_ptr, l_res_size, (1).to_natural_32)
					if l_cy.to_boolean then
						l_res_ptr[l_res_size] := l_cy
						l_res_size := l_res_size + 1
					end
				else
					l_res_ptr[0] := (1).to_natural_32
					l_res_size := (1).to_integer_32
				end
				a_res.item.mp_size := (-l_res_size).to_integer_32
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
				l_return := True
			else
				from
				until
					(l_break)
				loop
					l_break := False
					l_mpz_srcptr_swap_tmp := l_op1
					l_op1 := l_op2
					l_op2 := l_mpz_srcptr_swap_tmp
					l_break := True
				end
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						l_mp_srcptr_swap_tmp := l_op1_ptr
						l_op1_ptr := l_op2_ptr
						l_op2_ptr := l_mp_srcptr_swap_tmp
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						l_mp_size_t_swap_tmp := l_op1_size
						l_op1_size := l_op2_size
						l_op2_size := l_mp_size_t_swap_tmp
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
			end
			if not l_return then
				l_op2_size := -l_op2_size
				l_res_alloc := l_op2_size
				if (builtin_expect ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp_13 := (l_aaf.new ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp_13 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_opx_0 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_13);
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_opx_0, l_op2_ptr, l_op2_size, (1).to_natural_32).do_nothing
				l_op2_ptr := l_opx_0
				l_op2_size := l_op2_size - (l_op2_ptr[(l_op2_size - 1)] = {NATURAL_32} 0).to_integer
				if (a_res.item.mp_alloc).to_integer_32 < l_res_alloc then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_res, l_res_alloc).do_nothing
					l_op1_ptr := l_op1.item.mp_d
					l_res_ptr := a_res.item.mp_d
				end
				if l_op1_size >= l_op2_size then
					l_i := l_op2_size - 1
					from
					until
						not (not (l_break) and then (l_i >= 0))
					loop
						l_break := False
						if (((l_op1_ptr[l_i]).bit_not).bit_and (l_op2_ptr[l_i])) /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_i := l_i - 1
						end
					end
					l_break := False
					l_res_size := l_i + 1
					l_count := l_res_size
				else
					l_res_size := l_op2_size
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_res_ptr + l_op1_size, l_op2_ptr + l_op1_size, l_op2_size - l_op1_size)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_count := l_op1_size
				end
				if l_res_size /= 0 then
					l_i := l_count - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := (((l_op1_ptr[l_i]).bit_not).bit_and (l_op2_ptr[l_i]))
						l_i := l_i - 1
					end
					l_cy_0 := (create {P_GMP_STATIC}).gmpn_add_1 (l_res_ptr, l_res_ptr, l_res_size, (1).to_natural_32)
					if l_cy_0.to_boolean then
						l_res_ptr[l_res_size] := l_cy_0
						l_res_size := l_res_size + 1
					end
				else
					l_res_ptr[0] := (1).to_natural_32
					l_res_size := (1).to_integer_32
				end
				a_res.item.mp_size := (-l_res_size).to_integer_32
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
			end
		end

end
