class
	P_JACOBI_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_jacobi (a_a, a_b: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_asrcp: CE_POINTER [NATURAL_32]
			l_bsrcp: CE_POINTER [NATURAL_32]
			l_asize: INTEGER_32
			l_bsize: INTEGER_32
			l_ap: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_alow: NATURAL_32
			l_blow: NATURAL_32
			l_ahigh: NATURAL_32
			l_bhigh: NATURAL_32
			l_asecond: NATURAL_32
			l_bsecond: NATURAL_32
			l_atwos: NATURAL_32
			l_btwos: NATURAL_32
			l_result_bit1: INTEGER_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_tmp_0: INTEGER_32
			l_a_ptr: CE_POINTER [NATURAL_32]
			l_a_size: INTEGER_32
			l_b: NATURAL_32
			l_a_ptr_0: CE_POINTER [NATURAL_32]
			l_a_size_0: INTEGER_32
			l_b_0: NATURAL_32
			l_tmp_20: CE_POINTER [ANY]
			l_mp_ptr_swap_tmp: CE_POINTER [NATURAL_32]
			l_mp_size_t_swap_tmp: INTEGER_32
			l_mp_limb_t_swap_tmp: NATURAL_32
			l_rp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_tmp_35: CE_POINTER [ANY]
			l_mp_ptr_swap_tmp_0: CE_POINTER [NATURAL_32]
			l_mp_size_t_swap_tmp_0: INTEGER_32
			l_mp_limb_t_swap_tmp_0: NATURAL_32
			l_twos: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_NATURAL_32_POINTER} l_bsrcp.make
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_asize := (a_a.item.mp_size).to_integer_32
					l_asrcp := a_a.item.mp_d
					l_alow := l_asrcp[0]
					l_bsize := (a_b.item.mp_size).to_integer_32
					if l_bsize /= 0 then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if l_asize /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if l_asize /= -1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if l_alow = {NATURAL_32} 1 then
							l_tmp := 1
						else
							l_tmp := 0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_tmp := 0
				when 8 then -- if done
						Result := l_tmp
						l_return := True
				when 9 then -- if done
					if l_return then
						l_pos := -1 + 19 -- skip if block
					end
				when 10 then -- if:
						l_bsrcp := a_b.item.mp_d
						l_blow := l_bsrcp[0]
						if l_asize /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 11 then -- if:
						if l_bsize /= 1 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 14 then -- else:
						if l_bsize /= -1 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L___0:
						if l_blow = {NATURAL_32} 1 then
							l_tmp_0 := 1
						else
							l_tmp_0 := 0
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						l_tmp_0 := 0
				when 18 then -- if done
						Result := l_tmp_0
						l_return := True
				when 19 then -- if done | if done
					if not l_return and then (((((l_alow).bit_or (l_blow))).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0) then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 26 -- skip if block
					end
				when 20 then -- if:
						l_result_bit1 := ((((l_asize < 0).to_integer).bit_and ((l_bsize < 0).to_integer))).bit_shift_left (1)
						if l_bsize >= 0 then
							l_bsize := l_bsize
						else
							l_bsize := -l_bsize
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if not (builtin_expect ((l_blow = {NATURAL_32} 0).to_integer, 0)).to_boolean then
									l_break := True
								end
								if not (l_return or l_break) then
									l_bsize := l_bsize - 1
									l_bsrcp := l_bsrcp + 1
									l_blow := l_bsrcp.item
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_btwos := (builtin_ctzl (l_blow)).to_natural_32
							l_break := True
						end
						l_break := False
						l_blow := (l_blow).bit_shift_right (l_btwos.to_integer_32)
						if l_bsize > 1 then
							l_bsecond := l_bsrcp[1]
							if l_btwos /= {NATURAL_32} 0 then
								l_blow := (l_blow).bit_or (((((l_bsecond).bit_shift_left (({NATURAL_32} 32 - l_btwos).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295)))
							end
						end
						l_result_bit1 := (l_result_bit1).bit_xor ((((((l_asize < 0).to_integer).bit_shift_left (1))).bit_and (l_blow.to_integer_32)))
						if l_asize >= 0 then
							l_asize := l_asize
						else
							l_asize := -l_asize
						end
						if l_bsize /= 1 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 25 -- goto _L___1
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 23 then -- else:
						if l_bsize /= 2 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if (l_bsecond).bit_shift_right (l_btwos.to_integer_32) /= {NATURAL_32} 0 then
							l_pos := -1 + 26 -- skip if block
						end
				when 25 then -- if: | _L___1:
						l_result_bit1 := (l_result_bit1).bit_xor (((((l_btwos).bit_shift_left (1)).to_integer_32).bit_and (((((l_alow).bit_shift_right (1))).bit_xor (l_alow)).to_integer_32)))
						if l_blow = {NATURAL_32} 1 then
							Result := (1 - ((l_result_bit1).bit_and (2)))
							l_return := True
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_a_ptr := l_asrcp
								l_a_size := l_asize
								l_b := l_blow
								if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_a_size >= 22 then
										l_alow := (create {P_GMP_STATIC}).gmpn_mod_1 (l_a_ptr, l_a_size, l_b)
									else
										l_result_bit1 := (l_result_bit1).bit_xor (l_b.to_integer_32)
										l_alow := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_a_ptr, l_a_size, l_b)
									end
								else
									l_result_bit1 := (l_result_bit1).bit_xor (l_b.to_integer_32)
									l_alow := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_a_ptr, l_a_size, l_b)
								end
								l_break := True
							end
							l_break := False
							Result := ((create {P_GMP_IMPL_STATIC}).gmpn_jacobi_base (l_alow, l_blow, l_result_bit1))
							l_return := True
						end
				when 26 then -- if done | if done | if done
					if l_return then
						l_pos := -1 + 33 -- skip if block
					end
				when 27 then -- if:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if not (builtin_expect ((l_alow = {NATURAL_32} 0).to_integer, 0)).to_boolean then
									l_break := True
								end
								if not (l_return or l_break) then
									l_asize := l_asize - 1
									l_asrcp := l_asrcp + 1
									l_alow := l_asrcp.item
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_atwos := (builtin_ctzl (l_alow)).to_natural_32
							l_break := True
						end
						l_break := False
						l_result_bit1 := (l_result_bit1).bit_xor (((((l_atwos).bit_shift_left (1)).to_integer_32).bit_and (((((l_blow).bit_shift_right (1))).bit_xor (l_blow)).to_integer_32)))
						l_alow := (l_alow).bit_shift_right (l_atwos.to_integer_32)
						if l_asize > 1 then
							l_asecond := l_asrcp[1]
							if l_atwos /= {NATURAL_32} 0 then
								l_alow := (l_alow).bit_or (((((l_asecond).bit_shift_left (({NATURAL_32} 32 - l_atwos).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295)))
							end
						end
						l_result_bit1 := (l_result_bit1).bit_xor (((((l_btwos).bit_shift_left (1)).to_integer_32).bit_and (((((l_alow).bit_shift_right (1))).bit_xor (l_alow)).to_integer_32)))
						if l_asize /= 1 then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 32 -- goto _L___2
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 30 then -- else:
						if l_asize /= 2 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if (l_asecond).bit_shift_right (l_atwos.to_integer_32) /= {NATURAL_32} 0 then
							l_pos := -1 + 33 -- skip if block
						end
				when 32 then -- if: | _L___2:
						if l_alow = {NATURAL_32} 1 then
							Result := (1 - ((l_result_bit1).bit_and (2)))
							l_return := True
						end
						if not l_return then
							l_result_bit1 := (l_result_bit1).bit_xor (((((l_btwos).bit_shift_left (1)).to_integer_32).bit_and (((((l_alow).bit_shift_right (1))).bit_xor (l_alow)).to_integer_32)))
							l_result_bit1 := (l_result_bit1).bit_xor (((l_alow).bit_and (l_blow)).to_integer_32)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_a_ptr_0 := l_bsrcp
								l_a_size_0 := l_bsize
								l_b_0 := l_alow
								if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_a_size_0 >= 22 then
										l_blow := (create {P_GMP_STATIC}).gmpn_mod_1 (l_a_ptr_0, l_a_size_0, l_b_0)
									else
										l_result_bit1 := (l_result_bit1).bit_xor (l_b_0.to_integer_32)
										l_blow := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_a_ptr_0, l_a_size_0, l_b_0)
									end
								else
									l_result_bit1 := (l_result_bit1).bit_xor (l_b_0.to_integer_32)
									l_blow := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_a_ptr_0, l_a_size_0, l_b_0)
								end
								l_break := True
							end
							l_break := False
							Result := ((create {P_GMP_IMPL_STATIC}).gmpn_jacobi_base (l_blow, l_alow, l_result_bit1))
							l_return := True
						end
				when 33 then -- if done | if done | if done
					if l_return then
						l_pos := -1 + 53 -- skip if block
					end
				when 34 then -- if:
						l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((l_asize + l_bsize).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp_20 := (l_aaf.new (((l_asize + l_bsize).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp_20 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_asize + l_bsize).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_ap := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_20)
							l_bp := l_ap + l_asize
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_atwos /= {NATURAL_32} 0 then
								(create {P_GMP_STATIC}).gmpn_rshift (l_ap, l_asrcp, l_asize, l_atwos).do_nothing
								l_asize := l_asize - (l_ap[(l_asize - 1)] = {NATURAL_32} 0).to_integer
							else
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_ap, l_asrcp, l_asize)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
							end
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_btwos /= {NATURAL_32} 0 then
								(create {P_GMP_STATIC}).gmpn_rshift (l_bp, l_bsrcp, l_bsize, l_btwos).do_nothing
								l_bsize := l_bsize - (l_bp[(l_bsize - 1)] = {NATURAL_32} 0).to_integer
							else
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_bp, l_bsrcp, l_bsize)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
							end
							l_break := True
						end
						l_break := False
						if l_asize < l_bsize then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l_mp_ptr_swap_tmp := l_ap
									l_ap := l_bp
									l_bp := l_mp_ptr_swap_tmp
									l_break := True
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l_mp_size_t_swap_tmp := l_asize
									l_asize := l_bsize
									l_bsize := l_mp_size_t_swap_tmp
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								l_mp_limb_t_swap_tmp := l_alow
								l_alow := l_blow
								l_blow := l_mp_limb_t_swap_tmp
								l_break := True
							end
							l_break := False
							l_result_bit1 := (l_result_bit1).bit_xor (((l_alow).bit_and (l_blow)).to_integer_32)
						end
						if not (l_asize > l_bsize) then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((l_bsize + ((l_asize - l_bsize) + 1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp_35 := (l_aaf.new (((l_bsize + ((l_asize - l_bsize) + 1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp_35 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_bsize + ((l_asize - l_bsize) + 1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_rp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_35)
							l_qp := l_rp + l_bsize
							l_break := True
						end
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_tdiv_qr (l_qp, l_rp, (0).to_integer_32, l_ap, l_asize, l_bp, l_bsize)
						l_ap := l_rp
						l_asize := l_bsize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_asize > 0))
							loop
								l_break := False
								if l_ap[(l_asize - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_asize := l_asize - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if l_asize = 0 then
							l_pos := -1 + 54 -- goto zero
						end
				when 36 then
						l_alow := l_ap[0]
						l_pos := -1 + 50 -- goto strip_a
				when 37 then
						if (l_return or l_break) then
							l_pos := -1 + 52 -- skip loop
						end
				when 38 then -- loop body:
						l_break := False
						if not (l_asize < l_bsize) then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						l_pos := -1 + 47 -- goto _L___4
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 41 then -- else:
						if l_asize /= l_bsize then
							l_pos := -1 + 48 -- skip if block
						end
				when 42 then -- if:
						l_ahigh := l_ap[(l_asize - 1)]
						l_bhigh := l_bp[(l_asize - 1)]
						if not (l_ahigh < l_bhigh) then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						l_pos := -1 + 47 -- goto _L___4
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 45 then -- else:
						if l_ahigh /= l_bhigh then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						if not (((create {P_GMP_STATIC}).gmpn_cmp (l_ap, l_bp, l_asize - 1)) < 0) then
							l_pos := -1 + 48 -- skip if block
						end
				when 47 then -- if: | _L___4:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								l_mp_ptr_swap_tmp_0 := l_ap
								l_ap := l_bp
								l_bp := l_mp_ptr_swap_tmp_0
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								l_mp_size_t_swap_tmp_0 := l_asize
								l_asize := l_bsize
								l_bsize := l_mp_size_t_swap_tmp_0
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							l_mp_limb_t_swap_tmp_0 := l_alow
							l_alow := l_blow
							l_blow := l_mp_limb_t_swap_tmp_0
							l_break := True
						end
						l_break := False
						l_result_bit1 := (l_result_bit1).bit_xor (((l_alow).bit_and (l_blow)).to_integer_32)
				when 48 then -- if done | if done | if done | if done
						if l_asize = 1 then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:;
						(create {P_GMP_STATIC}).gmpn_sub (l_ap, l_ap, l_asize, l_bp, l_bsize).do_nothing
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_asize > 0))
							loop
								l_break := False
								if l_ap[(l_asize - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_asize := l_asize - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_alow := l_ap[0]
						if l_asize = 0 then
							l_pos := -1 + 54 -- goto zero
						end
				when 50 then -- strip_a:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if not (builtin_expect ((l_alow = {NATURAL_32} 0).to_integer, 0)).to_boolean then
									l_break := True
								end
								if not (l_return or l_break) then
									l_asize := l_asize - 1
									l_ap := l_ap + 1
									l_alow := l_ap.item
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if ((l_alow).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_twos := (builtin_ctzl (l_alow)).to_natural_32
								l_break := True
							end
							l_break := False
							l_result_bit1 := (l_result_bit1).bit_xor (((((l_twos).bit_shift_left (1)).to_integer_32).bit_and (((((l_blow).bit_shift_right (1))).bit_xor (l_blow)).to_integer_32)));
							(create {P_GMP_STATIC}).gmpn_rshift (l_ap, l_ap, l_asize, l_twos).do_nothing
							l_asize := l_asize - (l_ap[(l_asize - 1)] = {NATURAL_32} 0).to_integer
							l_alow := l_ap[0]
						end
				when 51 then -- if done
						l_pos := -1 + 37 -- back to loop condition
				when 52 then -- loop done
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
						if l_alow = {NATURAL_32} 1 then
							Result := (1 - ((l_result_bit1).bit_and (2)))
							l_return := True
						end
				when 53 then -- if done
					if not l_return then
						l_result_bit1 := (l_result_bit1).bit_xor (((l_alow).bit_and (l_blow)).to_integer_32)
						Result := ((create {P_GMP_IMPL_STATIC}).gmpn_jacobi_base (l_blow, l_alow, l_result_bit1))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 55 -- skip if block
					end
				when 54 then -- if: | zero:
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
						Result := 0
				when 55 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
