class
	P_KRONZS_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_kronecker_si (a_a: CE_POINTER [PD_MPZ_STRUCT]; a_b: INTEGER_32): INTEGER_32
		local
			l_a_ptr: CE_POINTER [NATURAL_32]
			l_a_size: INTEGER_32
			l_a_rem: NATURAL_32
			l_b_limb: NATURAL_32
			l_result_bit1: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp_0: INTEGER_32
			l_a_low: NATURAL_32
			l_twos: INTEGER_32
			l_tmp_1: INTEGER_32
			l_a_ptr2: CE_POINTER [NATURAL_32]
			l_a_size2: INTEGER_32
			l_b: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_POINTER} l_a_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a_size := (a_a.item.mp_size).to_integer_32
					if l_a_size = 0 then
						if a_b = 1 then
							l_tmp := 1
						elseif a_b = -1 then
							l_tmp := 1
						else
							l_tmp := 0
						end
						Result := l_tmp
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_result_bit1 := ((((l_a_size < 0).to_integer).bit_and ((a_b < 0).to_integer))).bit_shift_left (1)
						if a_b >= 0 then
							l_tmp_0 := a_b
						else
							l_tmp_0 := -a_b
						end
						l_b_limb := l_tmp_0.to_natural_32
						l_a_ptr := a_a.item.mp_d
						if ((l_b_limb).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 2 then -- if:
						l_a_low := l_a_ptr[0]
						if l_b_limb /= {NATURAL_32} 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if l_a_size /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if l_a_size /= -1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						if l_a_low = {NATURAL_32} 1 then
							l_tmp_1 := 1
						else
							l_tmp_1 := 0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_tmp_1 := 0
				when 10 then -- if done
						Result := l_tmp_1
						l_return := True
				when 11 then -- if done
						if not l_return and then (not ((l_a_low).bit_and ({NATURAL_32} 1)).to_boolean) then
							Result := 0
							l_return := True
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_twos := builtin_ctzl (l_b_limb)
								l_break := True
							end
							l_break := False
							l_b_limb := (l_b_limb).bit_shift_right (l_twos)
							l_result_bit1 := (l_result_bit1).bit_xor (((((l_twos).bit_shift_left (1))).bit_and (((((l_a_low).bit_shift_right (1))).bit_xor (l_a_low)).to_integer_32)))
						end
				when 12 then -- if done | if done
					if not l_return and then (l_b_limb = {NATURAL_32} 1) then
						Result := (1 - ((l_result_bit1).bit_and (2)))
						l_return := True
					end
					if not l_return then
						l_result_bit1 := (l_result_bit1).bit_xor ((((((l_a_size < 0).to_integer).bit_shift_left (1))).bit_and (l_b_limb.to_integer_32)))
						if l_a_size >= 0 then
							l_a_size := l_a_size
						else
							l_a_size := -l_a_size
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_a_ptr2 := l_a_ptr
							l_a_size2 := l_a_size
							l_b := l_b_limb
							if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_a_size2 >= 22 then
									l_a_rem := (create {P_GMP_STATIC}).gmpn_mod_1 (l_a_ptr2, l_a_size2, l_b)
								else
									l_result_bit1 := (l_result_bit1).bit_xor (l_b.to_integer_32)
									l_a_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_a_ptr2, l_a_size2, l_b)
								end
							else
								l_result_bit1 := (l_result_bit1).bit_xor (l_b.to_integer_32)
								l_a_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_a_ptr2, l_a_size2, l_b)
							end
							l_break := True
						end
						l_break := False
						Result := ((create {P_GMP_IMPL_STATIC}).gmpn_jacobi_base (l_a_rem, l_b_limb, l_result_bit1))
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
