class
	P_LUCNUM_UI_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBMPZ_ASSEMBLER

feature {ANY} -- public routines

	gmpz_lucnum_ui (a_ln: CE_POINTER [PD_MPZ_STRUCT]; a_n: NATURAL_32)
		local
			l_n: NATURAL_32
			l_lalloc: INTEGER_32
			l_xalloc: INTEGER_32
			l_lsize: INTEGER_32
			l_xsize: INTEGER_32
			l_lp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_xp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_c: NATURAL_32
			l_zeros: INTEGER_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp_3: CE_POINTER [ANY]
			l_yalloc: INTEGER_32
			l_ysize: INTEGER_32
			l_yp: CE_POINTER [NATURAL_32]
			l_tmp_8: CE_POINTER [ANY]
			l_ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_mp_ptr_swap_tmp: CE_POINTER [NATURAL_32]
			l_ptr_dummy_0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_mp_ptr_swap_tmp_0: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_lp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_xp.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_ptr_dummy_0.make (<<1>>)

			l_n := a_n
			if l_n <= {NATURAL_32} 46 then
				a_ln.item.mp_d[0] := ((create {P_GMP_IMPL_STATIC}).gmp_fib_table[(l_n + {NATURAL_32} 1).to_integer_32] + {NATURAL_32} 2 * (create {P_GMP_IMPL_STATIC}).gmp_fib_table[(l_n.to_integer_32 - 1) + 1])
				a_ln.item.mp_size := 1
				l_return := True
			end
			if not l_return then
				l_lalloc := ((((l_n // {NATURAL_32} 32) * {NATURAL_32} 23) // {NATURAL_32} 32).to_integer_32 + 4) + 2
				if (builtin_expect ((l_lalloc > (a_ln.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_ln, l_lalloc).do_nothing
				end
				l_lp.item := a_ln.item.mp_d
				l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_xalloc := l_lalloc
				if (builtin_expect ((l_xalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp_3 := (l_aaf.new ((l_xalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp_3 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_xalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_xp.item := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_3)
				l_zeros := 0
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if ((l_n).bit_and ({NATURAL_32} 1)).to_boolean then
						l_yalloc := ((((l_n // {NATURAL_32} 2) // {NATURAL_32} 32) * {NATURAL_32} 23) // {NATURAL_32} 32).to_integer_32 + 4
						if (builtin_expect ((l_yalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp_8 := (l_aaf.new ((l_yalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp_8 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_yalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_yp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_8)
						l_xsize := (create {P_GMP_IMPL_STATIC}).gmpn_fib2_ui (l_xp.item, l_yp, l_n // {NATURAL_32} 2)
						l_ysize := l_xsize
						l_ysize := l_ysize - (l_yp[(l_ysize - 1)] = {NATURAL_32} 0).to_integer
						l_c := (create {P_GMP_STATIC}).gmpn_lshift (l_xp.item, l_xp.item, l_xsize, {NATURAL_32} 1)
						l_c := l_c + ((create {P_GMP_STATIC}).gmpn_add_n (l_xp.item, l_xp.item, l_yp, l_xsize))
						l_xp.item[l_xsize] := l_c
						l_xsize := l_xsize + (l_c /= {NATURAL_32} 0).to_integer
						l_c := (create {P_GMP_STATIC}).gmpn_mul (l_lp.item, l_xp.item, l_xsize, l_yp, l_ysize)
						l_lsize := l_xsize + l_ysize
						l_lsize := l_lsize - (l_c = {NATURAL_32} 0).to_integer
						l_c := (create {P_GMP_STATIC}).gmpn_lshift (l_xp.item, l_lp.item, l_lsize, {NATURAL_32} 2)
						l_c := l_c + ((create {P_GMP_STATIC}).gmpn_add_n (l_lp.item, l_lp.item, l_xp.item, l_lsize))
						l_lp.item[l_lsize] := l_c
						l_lsize := l_lsize + (l_c /= {NATURAL_32} 0).to_integer
						if ((l_n).bit_and ({NATURAL_32} 2)).to_boolean then
							l_lp.item[0] := l_lp.item[0] + ({NATURAL_32} 4)
						else
							from
							until
								(l_break)
							loop
								l_break := False
								asm18 (l_ptr_dummy, l_lp)
								l_break := True
							end
							l_break := False
						end
						l_break := True
					end
					if not (l_return or l_break) then
						from
						until
							(l_break)
						loop
							l_break := False
							l_mp_ptr_swap_tmp := l_xp.item
							l_xp.item := l_lp.item
							l_lp.item := l_mp_ptr_swap_tmp
							l_break := True
						end
						l_break := False
						l_zeros := l_zeros + 1
						l_n := l_n // ({NATURAL_32} 2)
						if l_n <= {NATURAL_32} 46 then
							l_lp.item[0] := ((create {P_GMP_IMPL_STATIC}).gmp_fib_table[(l_n + {NATURAL_32} 1).to_integer_32] + {NATURAL_32} 2 * (create {P_GMP_IMPL_STATIC}).gmp_fib_table[(l_n.to_integer_32 - 1) + 1])
							l_lsize := (1).to_integer_32
							l_break := True
						end
					end
				end
				l_break := False
				from
				until
					not (not (l_return) and then (l_zeros /= 0))
				loop
					(create {P_GMP_STATIC}).gmpn_sqr (l_xp.item, l_lp.item, l_lsize)
					l_lsize := l_lsize * (2)
					l_lsize := l_lsize - (l_xp.item[(l_lsize - 1)] = {NATURAL_32} 0).to_integer
					if ((l_n).bit_and ({NATURAL_32} 1)).to_boolean then
						l_xp.item[0] := l_xp.item[0] + ({NATURAL_32} 2)
						l_n := {NATURAL_32} 0
					else
						from
						until
							(l_break)
						loop
							l_break := False
							asm19 (l_ptr_dummy_0, l_xp)
							l_break := True
						end
						l_break := False
					end
					from
					until
						(l_break)
					loop
						l_break := False
						l_mp_ptr_swap_tmp_0 := l_xp.item
						l_xp.item := l_lp.item
						l_lp.item := l_mp_ptr_swap_tmp_0
						l_break := True
					end
					l_break := False
					l_zeros := l_zeros - 1
				end
				a_ln.item.mp_size := l_lsize.to_integer_32
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
			end
		end

end
