class
	P_MUL_I_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_mul_si (a_prod, a_mult: CE_POINTER [PD_MPZ_STRUCT]; a_small_mult: INTEGER_32)
		local
			l_size: INTEGER_32
			l_sign_product: INTEGER_32
			l_sml: NATURAL_32
			l_cy: NATURAL_32
			l_pp: CE_POINTER [NATURAL_32]
			l_return: BOOLEAN
		do
			l_size := (a_mult.item.mp_size).to_integer_32
			l_sign_product := l_size
			if l_size = 0 then
				a_prod.item.mp_size := 0
				l_return := True
			elseif a_small_mult = 0 then
				a_prod.item.mp_size := 0
				l_return := True
			end
			if not l_return then
				if l_size >= 0 then
					l_size := l_size
				else
					l_size := -l_size
				end
				if a_small_mult >= 0 then
					l_sml := a_small_mult.to_natural_32
				else
					l_sml := (-((a_small_mult + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32).to_natural_32
				end
				if l_sml <= {NATURAL_32} 4_294_967_295 then
					if (builtin_expect ((l_size + 1 > (a_prod.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						(create {P_REALLOC_STATIC}).gmpz_realloc (a_prod, l_size + 1).do_nothing
					end
					l_pp := a_prod.item.mp_d
					l_cy := (create {P_GMP_STATIC}).gmpn_mul_1 (l_pp, a_mult.item.mp_d, l_size, (l_sml).bit_and ({NATURAL_32} 4_294_967_295))
					l_pp[l_size] := l_cy
					l_size := l_size + (l_cy /= {NATURAL_32} 0).to_integer
				end
				if (((l_sign_product < 0).to_integer).bit_xor ((a_small_mult < 0).to_integer)).to_boolean then
					a_prod.item.mp_size := (-l_size).to_integer_32
				else
					a_prod.item.mp_size := l_size.to_integer_32
				end
			end
		end

	gmpz_mul_ui (a_prod, a_mult: CE_POINTER [PD_MPZ_STRUCT]; a_small_mult: NATURAL_32)
		local
			l_size: INTEGER_32
			l_sign_product: INTEGER_32
			l_sml: NATURAL_32
			l_cy: NATURAL_32
			l_pp: CE_POINTER [NATURAL_32]
			l_return: BOOLEAN
		do
			l_size := (a_mult.item.mp_size).to_integer_32
			l_sign_product := l_size
			if l_size = 0 then
				a_prod.item.mp_size := 0
				l_return := True
			elseif a_small_mult = {NATURAL_32} 0 then
				a_prod.item.mp_size := 0
				l_return := True
			end
			if not l_return then
				if l_size >= 0 then
					l_size := l_size
				else
					l_size := -l_size
				end
				l_sml := a_small_mult
				if l_sml <= {NATURAL_32} 4_294_967_295 then
					if (builtin_expect ((l_size + 1 > (a_prod.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						(create {P_REALLOC_STATIC}).gmpz_realloc (a_prod, l_size + 1).do_nothing
					end
					l_pp := a_prod.item.mp_d
					l_cy := (create {P_GMP_STATIC}).gmpn_mul_1 (l_pp, a_mult.item.mp_d, l_size, (l_sml).bit_and ({NATURAL_32} 4_294_967_295))
					l_pp[l_size] := l_cy
					l_size := l_size + (l_cy /= {NATURAL_32} 0).to_integer
				end
				if (((l_sign_product < 0).to_integer).bit_xor ((a_small_mult < {NATURAL_32} 0).to_integer)).to_boolean then
					a_prod.item.mp_size := (-l_size).to_integer_32
				else
					a_prod.item.mp_size := l_size.to_integer_32
				end
			end
		end

end
