class
	P_MUL_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_mul (a_w, a_u, a_v: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_u: CE_POINTER [PD_MPZ_STRUCT]
			l_v: CE_POINTER [PD_MPZ_STRUCT]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_wsize: INTEGER_32
			l_sign_product: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_free_me: CE_POINTER [NATURAL_32]
			l_free_me_size: NATURAL_32
			l_cy_limb: NATURAL_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_mpz_srcptr_swap_tmp: CE_POINTER [PD_MPZ_STRUCT]
			l_mp_size_t_swap_tmp: INTEGER_32
			l_tmp_4: CE_POINTER [ANY]
			l_tmp_9: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			l_u := a_u
			l_v := a_v
			l_usize := (l_u.item.mp_size).to_integer_32
			l_vsize := (l_v.item.mp_size).to_integer_32
			l_sign_product := (l_usize).bit_xor (l_vsize)
			if l_usize >= 0 then
				l_usize := l_usize
			else
				l_usize := -l_usize
			end
			if l_vsize >= 0 then
				l_vsize := l_vsize
			else
				l_vsize := -l_vsize
			end
			if l_usize < l_vsize then
				from
				until
					(l_break)
				loop
					l_break := False
					l_mpz_srcptr_swap_tmp := l_u
					l_u := l_v
					l_v := l_mpz_srcptr_swap_tmp
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_mp_size_t_swap_tmp := l_usize
					l_usize := l_vsize
					l_vsize := l_mp_size_t_swap_tmp
					l_break := True
				end
				l_break := False
			end
			if l_vsize = 0 then
				a_w.item.mp_size := 0
				l_return := True
			end
			if not l_return and then (l_vsize = 1) then
				if (builtin_expect ((l_usize + 1 > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_w, l_usize + 1).do_nothing
				end
				l_wp := a_w.item.mp_d
				l_cy_limb := (create {P_GMP_STATIC}).gmpn_mul_1 (l_wp, l_u.item.mp_d, l_usize, l_v.item.mp_d[0])
				l_wp[l_usize] := l_cy_limb
				l_usize := l_usize + (l_cy_limb /= {NATURAL_32} 0).to_integer
				if l_sign_product >= 0 then
					a_w.item.mp_size := l_usize.to_integer_32
				else
					a_w.item.mp_size := (-l_usize).to_integer_32
				end
				l_return := True
			end
			if not l_return then
				l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_free_me := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_up := l_u.item.mp_d
				l_vp := l_v.item.mp_d
				l_wp := a_w.item.mp_d
				l_wsize := l_usize + l_vsize
				if (a_w.item.mp_alloc).to_integer_32 < l_wsize then
					if l_wp.is_equal (l_up) then
						l_free_me := l_wp
						l_free_me_size := (a_w.item.mp_alloc).to_natural_32
					elseif l_wp.is_equal (l_vp) then
						l_free_me := l_wp
						l_free_me_size := (a_w.item.mp_alloc).to_natural_32
					else
						(create {P_GMP_IMPL_STATIC}).gmp_free_func.call ([create {CE_VOID_POINTER}.make_cast (l_wp), (a_w.item.mp_alloc * 4).to_natural_32])
					end
					a_w.item.mp_alloc := l_wsize.to_integer_32
					l_wp := create {CE_NATURAL_32_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_GMP_IMPL_STATIC}).gmp_allocate_func.pointer_item ([(l_wsize * 4).to_natural_32]))))
					a_w.item.mp_d := l_wp
				elseif l_wp.is_equal (l_up) then
					if (builtin_expect ((l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp_4 := (l_aaf.new ((l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp_4 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_up := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_4)
					if l_wp.is_equal (l_vp) then
						l_vp := l_up
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_up, l_wp, l_usize)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				elseif l_wp.is_equal (l_vp) then
					if (builtin_expect ((l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp_9 := (l_aaf.new ((l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp_9 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_vp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_9)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_vp, l_wp, l_vsize)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				if l_up.is_equal (l_vp) then
					(create {P_GMP_STATIC}).gmpn_sqr (l_wp, l_up, l_usize)
					l_cy_limb := l_wp[(l_wsize - 1)]
				else
					l_cy_limb := (create {P_GMP_STATIC}).gmpn_mul (l_wp, l_up, l_usize, l_vp, l_vsize)
				end
				l_wsize := l_wsize - (l_cy_limb = {NATURAL_32} 0).to_integer
				if l_sign_product < 0 then
					a_w.item.mp_size := (-l_wsize).to_integer_32
				else
					a_w.item.mp_size := l_wsize.to_integer_32
				end
				if not l_free_me.is_void then
					(create {P_GMP_IMPL_STATIC}).gmp_free_func.call ([create {CE_VOID_POINTER}.make_cast (l_free_me), l_free_me_size * {NATURAL_32} 4])
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
			end
		end

end
