class
	P_N_POW_UI_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBMPZ_ASSEMBLER

feature {ANY} -- public routines

	gmpz_n_pow_ui (a_r: CE_POINTER [PD_MPZ_STRUCT]; a_bp: CE_POINTER [NATURAL_32]; a_bsize: INTEGER_32; a_e: NATURAL_32)
		local
			l_bp: CE_POINTER [NATURAL_32]
			l_bsize: INTEGER_32
			l_e: NATURAL_32
			l_rp: CE_POINTER [NATURAL_32]
			l_rtwos_limbs: INTEGER_32
			l_ralloc: INTEGER_32
			l_rsize: INTEGER_32
			l_rneg: INTEGER_32
			l_i: INTEGER_32
			l_cnt: INTEGER_32
			l_btwos: INTEGER_32
			l_r_bp_overlap: INTEGER_32
			l_blimb: NATURAL_32
			l_rl: NATURAL_32
			l_rtwos_bits: NATURAL_32
			l_b_twolimbs: CE_ARRAY [NATURAL_32]
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_bsecond: NATURAL_32
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp_3: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp_6: CE_POINTER [NATURAL_32]
			l_tp_0: CE_POINTER [NATURAL_32]
			l_talloc: INTEGER_32
			l_tmp_10: CE_POINTER [ANY]
			l_mp_ptr_swap_tmp: CE_POINTER [NATURAL_32]
			l_mp_ptr_swap_tmp_0: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			l_cy_0: NATURAL_32
			l_parity: INTEGER_32
			l_p: CE_ARRAY [INTEGER_8]
			l_n_0: CE_ARRAY [NATURAL_32]
			l_mp_ptr_swap_tmp_1: CE_POINTER [NATURAL_32]
			l_mp_ptr_swap_tmp_2: CE_POINTER [NATURAL_32]
			l_cy_1: NATURAL_32
			l_mp_ptr_swap_tmp_3: CE_POINTER [NATURAL_32]
			l_cy_2: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_NATURAL_32_ARRAY} l_b_twolimbs.make (<<2>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_p.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_n_0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bp := a_bp
					l_bsize := a_bsize
					l_e := a_e
					if l_e = {NATURAL_32} 0 then
						a_r.item.mp_d[0] := (1).to_natural_32
						a_r.item.mp_size := 1
						l_return := True
					end
					if not l_return and then (l_bsize = 0) then
						a_r.item.mp_size := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						if l_bsize < 0 then
							if ((l_e).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
						l_rneg := l_tmp
						if l_bsize >= 0 then
							l_bsize := l_bsize
						else
							l_bsize := -l_bsize
						end
						l_r_bp_overlap := ((a_r.item.mp_d).is_equal (l_bp)).to_integer
						l_rtwos_limbs := (0).to_integer_32
						l_blimb := l_bp.item
						from
						until
							not (not (l_return) and then (l_blimb = {NATURAL_32} 0))
						loop
							l_rtwos_limbs := (l_rtwos_limbs.to_natural_32 + l_e).to_integer_32
							l_bsize := l_bsize - 1
							l_bp := l_bp + 1
							l_blimb := l_bp.item
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_btwos := builtin_ctzl (l_blimb)
							l_break := True
						end
						l_break := False
						l_blimb := (l_blimb).bit_shift_right (l_btwos)
						l_rtwos_bits := l_e * l_btwos.to_natural_32
						l_rtwos_limbs := (l_rtwos_limbs.to_natural_32 + l_rtwos_bits // {NATURAL_32} 32).to_integer_32
						l_rtwos_bits := l_rtwos_bits \\ ({NATURAL_32} 32)
						l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						l_rl := (1).to_natural_32
						if l_bsize /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if: | bsize_1:
						if not (not (l_return) and then (l_blimb <= (({NATURAL_32} 1).bit_shift_left (16)) - {NATURAL_32} 1)) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if ((l_e).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_rl := l_rl * l_blimb
						end
						l_e := (l_e).bit_shift_right ((1))
						if l_e = {NATURAL_32} 0 then
							l_pos := -1 + 5 -- goto got_rl
						end
				when 4 then
						l_blimb := l_blimb * l_blimb
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- got_rl:
						
						if l_rtwos_bits /= {NATURAL_32} 0 then
							if l_rl /= {NATURAL_32} 1 then
								if (l_rl).bit_shift_right (({NATURAL_32} 32 - l_rtwos_bits).to_integer_32) = {NATURAL_32} 0 then
									l_rl := (l_rl).bit_shift_left (l_rtwos_bits.to_integer_32)
									l_rtwos_bits := (0).to_natural_32
								end
							end
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 7 then -- else:
						if l_bsize /= 2 then
							l_pos := -1 + 11 -- skip if block
						end
				when 8 then -- if:
						l_bsecond := l_bp[1]
						if l_btwos /= 0 then
							l_blimb := (l_blimb).bit_or (((((l_bsecond).bit_shift_left ((32 - l_btwos)))).bit_and ({NATURAL_32} 4_294_967_295)))
						end
						l_bsecond := (l_bsecond).bit_shift_right (l_btwos)
						if l_bsecond = {NATURAL_32} 0 then
							l_bsize := (1).to_integer_32
							l_pos := -1 + 2 -- goto bsize_1
						end
				when 9 then
						l_bp := create {CE_NATURAL_32_POINTER}.make_cast (l_b_twolimbs)
						l_b_twolimbs[0] := l_blimb
						l_b_twolimbs[1] := l_bsecond
						l_blimb := l_bsecond
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 11 then -- else:
						if not (l_r_bp_overlap.to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						if l_btwos = 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L:
						if (builtin_expect ((l_bsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp_3 := (l_aaf.new ((l_bsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp_3 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_bsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_3)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_btwos = 0 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_bp, l_bsize)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
							else
								(create {P_GMP_STATIC}).gmpn_rshift (l_tp, l_bp, l_bsize, l_btwos.to_natural_32).do_nothing
								l_bsize := l_bsize - (l_tp[(l_bsize - 1)] = {NATURAL_32} 0).to_integer
							end
							l_break := True
						end
						l_break := False
						l_bp := l_tp
				when 16 then -- if done
						l_blimb := l_bp[(l_bsize - 1)]
				when 17 then -- if done | if done
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_cnt := builtin_clzl (l_blimb)
							l_break := True
						end
						l_break := False
						l_ralloc := (((l_bsize * 32 - l_cnt.to_integer_32).to_natural_32 * l_e) // {NATURAL_32} 32 + {NATURAL_32} 5).to_integer_32
						if (builtin_expect ((l_ralloc + l_rtwos_limbs > (a_r.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							(create {P_REALLOC_STATIC}).gmpz_realloc (a_r, l_ralloc + l_rtwos_limbs).do_nothing
						end
						l_rp := a_r.item.mp_d
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_rtwos_limbs /= 0 then
								l_dst := l_rp
								l_n := l_rtwos_limbs
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp_6 := l_dst
									l_dst := l_dst + 1
									l_tmp_6.item := (0).to_natural_32
									l_n := l_n - 1
									if not l_n.to_boolean then
										l_break := True
									end
								end
								l_break := False
							end
							l_break := True
						end
						l_break := False
						l_rp := l_rp + l_rtwos_limbs
						if l_e = {NATURAL_32} 0 then
							l_rp[0] := l_rl
							l_rsize := (1).to_integer_32
						else
							l_talloc := l_ralloc
							if l_bsize <= 1 then
								l_talloc := l_talloc // (2)
							elseif ((l_e).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
								l_talloc := l_talloc // (2)
							end
							if (builtin_expect ((l_talloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp_10 := (l_aaf.new ((l_talloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp_10 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_talloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_tp_0 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_10)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_cnt := builtin_clzl (l_e)
								l_break := True
							end
							l_break := False
							l_i := (32 - l_cnt) - 2
							if l_bsize = 1 then
								if ((l_i).bit_and (1)) = 0 then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_break)
										loop
											l_break := False
											l_mp_ptr_swap_tmp := l_rp
											l_rp := l_tp_0
											l_tp_0 := l_mp_ptr_swap_tmp
											l_break := True
										end
										l_break := False
										l_break := True
									end
									l_break := False
								end
								l_rp[0] := l_blimb
								l_rsize := (1).to_integer_32
								from
								until
									not (not (l_return) and then (l_i >= 0))
								loop
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_sqr (l_tp_0, l_rp, l_rsize)
										l_rsize := l_rsize * (2)
										l_rsize := l_rsize - (l_tp_0[(l_rsize - 1)] = {NATURAL_32} 0).to_integer
										l_break := True
									end
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_break)
										loop
											l_break := False
											l_mp_ptr_swap_tmp_0 := l_rp
											l_rp := l_tp_0
											l_tp_0 := l_mp_ptr_swap_tmp_0
											l_break := True
										end
										l_break := False
										l_break := True
									end
									l_break := False
									if ((l_e).bit_and (((1).bit_shift_left (l_i)).to_natural_32)) /= {NATURAL_32} 0 then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											l_cy := (create {P_GMP_STATIC}).gmpn_mul_1 (l_rp, l_rp, l_rsize, l_blimb)
											l_rp[l_rsize] := l_cy
											l_rsize := l_rsize + (l_cy /= {NATURAL_32} 0).to_integer
											l_break := True
										end
										l_break := False
									end
									l_i := l_i - 1
								end
								if l_rl /= {NATURAL_32} 1 then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										l_cy_0 := (create {P_GMP_STATIC}).gmpn_mul_1 (l_rp, l_rp, l_rsize, l_rl)
										l_rp[l_rsize] := l_cy_0
										l_rsize := l_rsize + (l_cy_0 /= {NATURAL_32} 0).to_integer
										l_break := True
									end
									l_break := False
								end
							else
								from
								until
									(l_break)
								loop
									l_break := False
									l_n_0.item := l_e
									l_n_0.item := (l_n_0.item).bit_xor (((l_n_0.item).bit_shift_right (16)))
									asm20 (l_p, l_n_0)
									l_parity := (l_p.item).to_integer_32
									l_break := True
								end
								l_break := False
								if ((((l_parity).bit_xor (l_i))).bit_and (1)) /= 0 then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_break)
										loop
											l_break := False
											l_mp_ptr_swap_tmp_1 := l_rp
											l_rp := l_tp_0
											l_tp_0 := l_mp_ptr_swap_tmp_1
											l_break := True
										end
										l_break := False
										l_break := True
									end
									l_break := False
								end
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_bp, l_bsize)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								l_rsize := l_bsize
								from
								until
									not (not (l_return) and then (l_i >= 0))
								loop
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_sqr (l_tp_0, l_rp, l_rsize)
										l_rsize := l_rsize * (2)
										l_rsize := l_rsize - (l_tp_0[(l_rsize - 1)] = {NATURAL_32} 0).to_integer
										l_break := True
									end
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_break)
										loop
											l_break := False
											l_mp_ptr_swap_tmp_2 := l_rp
											l_rp := l_tp_0
											l_tp_0 := l_mp_ptr_swap_tmp_2
											l_break := True
										end
										l_break := False
										l_break := True
									end
									l_break := False
									if ((l_e).bit_and (((1).bit_shift_left (l_i)).to_natural_32)) /= {NATURAL_32} 0 then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											l_cy_1 := (create {P_GMP_STATIC}).gmpn_mul (l_tp_0, l_rp, l_rsize, l_bp, l_bsize)
											l_rsize := l_rsize + (l_bsize - (l_cy_1 = {NATURAL_32} 0).to_integer)
											l_break := True
										end
										l_break := False
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											from
											until
												(l_break)
											loop
												l_break := False
												l_mp_ptr_swap_tmp_3 := l_rp
												l_rp := l_tp_0
												l_tp_0 := l_mp_ptr_swap_tmp_3
												l_break := True
											end
											l_break := False
											l_break := True
										end
										l_break := False
									end
									l_i := l_i - 1
								end
							end
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
						if l_rtwos_bits /= {NATURAL_32} 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_cy_2 := (create {P_GMP_STATIC}).gmpn_lshift (l_rp, l_rp, l_rsize, l_rtwos_bits.to_natural_32)
								l_rp[l_rsize] := l_cy_2
								l_rsize := l_rsize + (l_cy_2 /= {NATURAL_32} 0).to_integer
								l_break := True
							end
							l_break := False
						end
						l_rsize := l_rsize + l_rtwos_limbs
						if l_rneg.to_boolean then
							a_r.item.mp_size := (-l_rsize).to_integer_32
						else
							a_r.item.mp_size := l_rsize.to_integer_32
						end
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
