class
	P_NEXTPRIME_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public attributes

	primegap: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					2, 2, 4, 2, 4, 2, 4, 6, 2, 6, 4, 2, 4, 6, 6, 2, 6, 4, 2, 6, 4, 6, 8, 4, 2, 4, 2, 4, 14, 4, 6, 2,
					10, 2, 6, 6, 4, 6, 6, 2, 10, 2, 4, 2, 12, 12, 4, 2, 4, 6, 2, 10, 6, 6, 6, 2, 6, 4, 2, 10, 14, 4,
					2, 4, 14, 6, 10, 2, 4, 6, 8, 6, 6, 4, 6, 8, 4, 8, 10, 2, 10, 2, 6, 4, 6, 8, 4, 2, 4, 12, 8, 4, 8,
					4, 6, 12, 2, 18, 6, 10, 6, 6, 2, 6, 10, 6, 6, 2, 6, 6, 4, 2, 12, 10, 2, 4, 6, 6, 2, 12, 4, 6, 8,
					10, 8, 10, 8, 6, 6, 4, 8, 6, 4, 8, 4, 14, 10, 12, 2, 10, 2, 4, 2, 10, 14, 4, 2, 4, 14, 4, 2, 4, 20,
					4, 8, 10, 8, 4, 6, 6, 14, 4, 6, 6, 8, 6, 12
				>>)
		end

feature {ANY} -- public routines

	gmpz_nextprime (a_p, a_n: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_moduli: CE_POINTER [NATURAL_16]
			l_difference: NATURAL_32
			l_i: INTEGER_32
			l_prime_limit: NATURAL_32
			l_prime: NATURAL_32
			l_cnt: INTEGER_32
			l_pn: INTEGER_32
			l_nbits: NATURAL_32
			l_incr: NATURAL_32
			l_r: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_CMP_UI_STATIC}).gmpz_cmp_ui (a_n, {NATURAL_32} 2)) < 0 then
						(create {P_SET_UI_STATIC}).gmpz_set_ui (a_p, {NATURAL_32} 2)
						l_return := True
					end
					if not l_return then
						(create {P_AORS_UI_STATIC}).gmpz_add_ui (a_p, a_n, {NATURAL_32} 1);
						(create {P_SETBIT_STATIC}).gmpz_setbit (a_p, (0).to_natural_32)
						if ((create {P_CMP_UI_STATIC}).gmpz_cmp_ui (a_p, {NATURAL_32} 7)) <= 0 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_pn := (a_p.item.mp_size).to_integer_32
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_cnt := builtin_clzl (a_p.item.mp_d[(l_pn - 1)])
							l_break := True
						end
						l_break := False
						l_nbits := (l_pn * 32 - l_cnt.to_integer_32).to_natural_32
						if l_nbits // {NATURAL_32} 2 >= {NATURAL_32} 167 then
							l_prime_limit := {NATURAL_32} 166
						else
							l_prime_limit := (l_nbits // {NATURAL_32} 2).to_natural_32
						end
						l_moduli := create {CE_NATURAL_16_POINTER}.make_cast ((l_aaf.new ((l_prime_limit * {PLATFORM}.Natural_16_bytes.to_natural_32) * {PLATFORM}.Natural_16_bytes.to_natural_32)))
				when 2 then -- loop condition:
						if (l_return) then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						l_prime := {NATURAL_32} 3
						l_i := 0
						from
						until
							not (l_i.to_natural_32 < l_prime_limit)
						loop
							l_moduli[l_i] := ((create {P_FDIV_UI_STATIC}).gmpz_fdiv_ui (a_p, l_prime)).to_natural_16
							l_prime := l_prime + (primegap.item[l_i]).to_natural_32
							l_i := l_i + 1
						end
						l_incr := {NATURAL_32} 0
						l_difference := l_incr.to_natural_32
				when 4 then -- loop condition:
						if not (not (l_return) and then (l_incr < {NATURAL_32} 65_536)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 5 then -- loop body:
						l_prime := {NATURAL_32} 3
						l_i := 0
				when 6 then -- loop condition:
						if not (l_i.to_natural_32 < l_prime_limit) then
							l_pos := -1 + 9 -- skip loop
						end
				when 7 then -- loop body:
						l_r := (((l_moduli[l_i]).to_natural_32 + l_incr).to_natural_32 \\ l_prime).to_natural_32
						l_prime := l_prime + (primegap.item[l_i]).to_natural_32
						if l_r = {NATURAL_32} 0 then
							l_pos := -1 + 10 -- goto next
						end
				when 8 then
						l_i := l_i + 1
						l_pos := -1 + 6 -- back to loop condition
				when 9 then -- loop done;
						(create {P_AORS_UI_STATIC}).gmpz_add_ui (a_p, a_p, l_difference)
						l_difference := {NATURAL_32} 0
						if ((create {P_MILLERRABIN_STATIC}).gmpz_millerrabin (a_p, 25)).to_boolean then
							l_pos := -1 + 12 -- goto done
						end
				when 10 then -- next:
						l_incr := l_incr + ({NATURAL_32} 2)
						l_difference := l_difference + ({NATURAL_32} 2)
						l_pos := -1 + 4 -- back to loop condition
				when 11 then -- loop done;
						(create {P_AORS_UI_STATIC}).gmpz_add_ui (a_p, a_p, l_difference)
						l_difference := {NATURAL_32} 0
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- done:
						
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
