class
	P_REMOVE_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_remove (a_dest, a_src, a_f: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l_fpow: CE_ARRAY [CE_ARRAY [PD_MPZ_STRUCT]]
			l_x: CE_ARRAY [PD_MPZ_STRUCT]
			l_rem: CE_ARRAY [PD_MPZ_STRUCT]
			l_pwr: NATURAL_32
			l_p: INTEGER_32
			l_s0: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_ARRAY_ARRAY [PD_MPZ_STRUCT]} l_fpow.make (<<32, 1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_x.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_rem.make (<<1>>)

			if ((create {P_CMP_UI_STATIC}).gmpz_cmp_ui (a_f, {NATURAL_32} 1)) <= 0 then
				(create {P_GMP_IMPL_STATIC}).gmp_divide_by_zero
			end
			if a_src.item.mp_size = 0 then
				if not a_src.is_equal (a_dest) then
					(create {P_SET_STATIC}).gmpz_set (a_dest, a_src)
				end
				Result := (0).to_natural_32
				l_return := True
			end
			if not l_return then
				if ((create {P_CMP_UI_STATIC}).gmpz_cmp_ui (a_f, {NATURAL_32} 2)) = 0 then
					l_s0 := (create {P_SCAN1_STATIC}).gmpz_scan1 (a_src, (0).to_natural_32);
					(create {P_CFDIV_Q_2EXP_STATIC}).gmpz_fdiv_q_2exp (a_dest, a_src, l_s0)
					Result := l_s0
					l_return := True
				end
			end
			if not l_return then
				(create {P_INIT_STATIC}).gmpz_init (l_rem);
				(create {P_INIT_STATIC}).gmpz_init (l_x)
				l_pwr := (0).to_natural_32;
				(create {P_INIT_STATIC}).gmpz_init (l_fpow[0]);
				(create {P_SET_STATIC}).gmpz_set (l_fpow[0], a_f);
				(create {P_SET_STATIC}).gmpz_set (a_dest, a_src)
				l_p := 0
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_TDIV_QR_STATIC}).gmpz_tdiv_qr (l_x, l_rem, a_dest, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_fpow[l_p])))
					if l_rem[0].mp_size /= 0 then
						l_break := True
					end
					if not (l_break) then
						(create {P_INIT_STATIC}).gmpz_init (l_fpow[l_p + 1]);
						(create {P_MUL_STATIC}).gmpz_mul (l_fpow[l_p + 1], create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_fpow[l_p])), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_fpow[l_p])));
						(create {P_SET_STATIC}).gmpz_set (a_dest, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x))
						l_p := l_p + 1
					end
				end
				l_break := False
				l_pwr := (((1).bit_shift_left (l_p)) - 1).to_natural_32;
				(create {P_CLEAR_STATIC}).gmpz_clear (l_fpow[l_p])
				from
				until
					(l_break)
				loop
					l_break := False
					l_p := l_p - 1
					if not (l_p >= 0) then
						l_break := True
					end
					if not (l_break) then
						(create {P_TDIV_QR_STATIC}).gmpz_tdiv_qr (l_x, l_rem, a_dest, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_fpow[l_p])))
						if l_rem[0].mp_size = 0 then
							l_pwr := l_pwr + ((1).bit_shift_left (l_p)).to_natural_32;
							(create {P_SET_STATIC}).gmpz_set (a_dest, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x))
						end
						(create {P_CLEAR_STATIC}).gmpz_clear (l_fpow[l_p])
					end
				end
				l_break := False;
				(create {P_CLEAR_STATIC}).gmpz_clear (l_x);
				(create {P_CLEAR_STATIC}).gmpz_clear (l_rem)
				Result := l_pwr
			end
		end

end
