class
	P_SETBIT_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBMPZ_ASSEMBLER

feature {ANY} -- public routines

	gmpz_setbit (a_d: CE_POINTER [PD_MPZ_STRUCT]; a_bit_index: NATURAL_32)
		local
			l_bit_index: CE_ARRAY [NATURAL_32]
			l_dsize: INTEGER_32
			l_dp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_limb_index: CE_ARRAY [INTEGER_32]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp_1: CE_POINTER [NATURAL_32]
			l_zero_bound: INTEGER_32
			l_dlimb: NATURAL_32
			l_tmp_2: INTEGER_32
			l_i: INTEGER_32
			l_ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_bit_index.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_dp.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_limb_index.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_ptr_dummy.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bit_index.item := a_bit_index
					l_dsize := (a_d.item.mp_size).to_integer_32
					l_dp.item := a_d.item.mp_d
					l_limb_index.item := (l_bit_index.item // {NATURAL_32} 32).to_integer_32
					if not (l_dsize >= 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_limb_index.item < l_dsize then
							l_dp.item[l_limb_index.item] := (l_dp.item[l_limb_index.item]).bit_or ((({NATURAL_32} 1).bit_shift_left ((l_bit_index.item \\ {NATURAL_32} 32).to_integer_32)))
							a_d.item.mp_size := l_dsize.to_integer_32
						else
							if (builtin_expect (((a_d.item.mp_alloc).to_integer_32 < l_limb_index.item + 1).to_integer, 0)).to_boolean then
								l_dp.item := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_REALLOC_STATIC}).gmpz_realloc (a_d, l_limb_index.item + 1)))
							end
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_limb_index.item - l_dsize /= 0 then
									l_dst := l_dp.item + l_dsize
									l_n := l_limb_index.item - l_dsize
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp_1 := l_dst
										l_dst := l_dst + 1
										l_tmp_1.item := (0).to_natural_32
										l_n := l_n - 1
										if not l_n.to_boolean then
											l_break := True
										end
									end
									l_break := False
								end
								l_break := True
							end
							l_break := False
							l_dp.item[l_limb_index.item] := ({NATURAL_32} 1).bit_shift_left ((l_bit_index.item \\ {NATURAL_32} 32).to_integer_32)
							a_d.item.mp_size := (l_limb_index.item + 1).to_integer_32
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else:
						l_dsize := -l_dsize
						l_zero_bound := (0).to_integer_32
						from
						until
							(l_dp.item[l_zero_bound] /= {NATURAL_32} 0)
						loop
							l_zero_bound := l_zero_bound + 1
						end
						if not (l_limb_index.item > l_zero_bound) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_limb_index.item < l_dsize then
							l_dlimb := l_dp.item[l_limb_index.item]
							l_dlimb := (l_dlimb).bit_and ((((({NATURAL_32} 1).bit_shift_left ((l_bit_index.item \\ {NATURAL_32} 32).to_integer_32))).bit_not))
							l_dp.item[l_limb_index.item] := l_dlimb
							if l_dlimb = {NATURAL_32} 0 then
								if l_limb_index.item = l_dsize - 1 then
									l_tmp_2 := 1
								else
									l_tmp_2 := 0
								end
							else
								l_tmp_2 := 0
							end
							if (builtin_expect ((l_tmp_2 /= 0).to_integer, 0)).to_boolean then
								from
								until
									(l_break)
								loop
									l_break := False
									l_dsize := l_dsize - 1
									if l_dsize > 0 then
										if l_dp.item[(l_dsize - 1)] /= {NATURAL_32} 0 then
											l_break := True
										end
									else
										l_break := True
									end
								end
								l_break := False
								a_d.item.mp_size := (-l_dsize).to_integer_32
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else:
						if l_limb_index.item /= l_zero_bound then
							l_pos := -1 + 15 -- skip if block
						end
				when 7 then -- if:
						l_dp.item[l_limb_index.item] := (((l_dp.item[l_limb_index.item] - {NATURAL_32} 1)).bit_and (((({NATURAL_32} 1).bit_shift_left ((l_bit_index.item \\ {NATURAL_32} 32).to_integer_32))).bit_not)) + {NATURAL_32} 1
						if l_dp.item[l_limb_index.item] /= {NATURAL_32} 0 then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						l_i := l_limb_index.item + 1
				when 9 then -- loop condition:
						if not (l_i < l_dsize) then
							l_pos := -1 + 12 -- skip loop
						end
				when 10 then -- loop body:
						l_dp.item[l_i] := (l_dp.item[l_i]) + 1
						if l_dp.item[l_i] /= {NATURAL_32} 0 then
							l_pos := -1 + 13 -- goto fin
						end
				when 11 then
						l_i := l_i + 1
						l_pos := -1 + 9 -- back to loop condition
				when 12 then -- loop done
						l_dsize := l_dsize + 1
						if (builtin_expect (((a_d.item.mp_alloc).to_integer_32 < l_dsize).to_integer, 0)).to_boolean then
							l_dp.item := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_REALLOC_STATIC}).gmpz_realloc (a_d, l_dsize)))
						end
						l_dp.item[l_i] := (1).to_natural_32
						a_d.item.mp_size := (-l_dsize).to_integer_32
				when 13 then -- fin:
						
				when 14 then -- if done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						from
						until
							(l_break)
						loop
							l_break := False
							asm24 (l_ptr_dummy, l_dp, l_limb_index, l_bit_index)
							l_break := True
						end
						l_break := False
						l_dsize := l_dsize - (l_dp.item[(l_dsize - 1)] = {NATURAL_32} 0).to_integer
						a_d.item.mp_size := (-l_dsize).to_integer_32
				when 16 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
