class
	P_TDIV_QR_UI_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_tdiv_qr_ui (a_quot, a_rem, a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32): NATURAL_32
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_qn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_rl: NATURAL_32
			l_return: BOOLEAN
		do
			if a_divisor = {NATURAL_32} 0 then
				(create {P_GMP_IMPL_STATIC}).gmp_divide_by_zero
			end
			l_ns := (a_dividend.item.mp_size).to_integer_32
			if l_ns = 0 then
				a_quot.item.mp_size := 0
				a_rem.item.mp_size := 0
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				if (builtin_expect ((l_nn > (a_quot.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_quot, l_nn).do_nothing
				end
				l_qp := a_quot.item.mp_d
				l_np := a_dividend.item.mp_d
				l_rl := (create {P_GMP_STATIC}).gmpn_divrem_1 (l_qp, (0).to_integer_32, l_np, l_nn, a_divisor)
				if l_rl = {NATURAL_32} 0 then
					a_rem.item.mp_size := 0
				else
					if l_ns >= 0 then
						a_rem.item.mp_size := 1
					else
						a_rem.item.mp_size := -1
					end
					a_rem.item.mp_d[0] := l_rl
				end
				l_qn := l_nn - (l_qp[(l_nn - 1)] = {NATURAL_32} 0).to_integer
				if l_ns >= 0 then
					a_quot.item.mp_size := l_qn.to_integer_32
				else
					a_quot.item.mp_size := (-l_qn).to_integer_32
				end
				Result := l_rl
			end
		end

end
