class
	PD_GMP_RANDFNPTR_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_randseed_fn: CE_ROUTINE
				a_randget_fn: CE_ROUTINE
				a_randclear_fn: CE_ROUTINE
				a_randiset_fn: CE_ROUTINE
			])
		require else
			a_data /= Void
		do
			make
			Current.randseed_fn := a_data.a_randseed_fn
			Current.randget_fn := a_data.a_randget_fn
			Current.randclear_fn := a_data.a_randclear_fn
			Current.randiset_fn := a_data.a_randiset_fn
		end

feature {ANY} -- fields

	randseed_fn: CE_ROUTINE assign set_randseed_fn
		do
			create Result.make_shared (c__randseed_fn (internal_c_pointer))
		end

	randget_fn: CE_ROUTINE assign set_randget_fn
		do
			create Result.make_shared (c__randget_fn (internal_c_pointer))
		end

	randclear_fn: CE_ROUTINE assign set_randclear_fn
		do
			create Result.make_shared (c__randclear_fn (internal_c_pointer))
		end

	randiset_fn: CE_ROUTINE assign set_randiset_fn
		do
			create Result.make_shared (c__randiset_fn (internal_c_pointer))
		end

feature {ANY} -- field setters

	set_randseed_fn (a_randseed_fn: CE_ROUTINE)
		do
			c__set_randseed_fn (internal_c_pointer, a_randseed_fn.c_pointer)
		end

	set_randget_fn (a_randget_fn: CE_ROUTINE)
		do
			c__set_randget_fn (internal_c_pointer, a_randget_fn.c_pointer)
		end

	set_randclear_fn (a_randclear_fn: CE_ROUTINE)
		do
			c__set_randclear_fn (internal_c_pointer, a_randclear_fn.c_pointer)
		end

	set_randiset_fn (a_randiset_fn: CE_ROUTINE)
		do
			c__set_randiset_fn (internal_c_pointer, a_randiset_fn.c_pointer)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return sizeof(struct __anonstruct_gmp_randfnptr_t_11);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return __alignof__(struct __anonstruct_gmp_randfnptr_t_11);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__randseed_fn (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmpz.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_gmp_randfnptr_t_11 *)$a_c_pointer)->randseed_fn;"
		end

	c__randget_fn (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmpz.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_gmp_randfnptr_t_11 *)$a_c_pointer)->randget_fn;"
		end

	c__randclear_fn (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmpz.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_gmp_randfnptr_t_11 *)$a_c_pointer)->randclear_fn;"
		end

	c__randiset_fn (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmpz.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_gmp_randfnptr_t_11 *)$a_c_pointer)->randiset_fn;"
		end

	c__set_randseed_fn (a_c_pointer: POINTER; a_randseed_fn: POINTER)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct __anonstruct_gmp_randfnptr_t_11 *)$a_c_pointer)->randseed_fn = $a_randseed_fn;"
		end

	c__set_randget_fn (a_c_pointer: POINTER; a_randget_fn: POINTER)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct __anonstruct_gmp_randfnptr_t_11 *)$a_c_pointer)->randget_fn = $a_randget_fn;"
		end

	c__set_randclear_fn (a_c_pointer: POINTER; a_randclear_fn: POINTER)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct __anonstruct_gmp_randfnptr_t_11 *)$a_c_pointer)->randclear_fn = $a_randclear_fn;"
		end

	c__set_randiset_fn (a_c_pointer: POINTER; a_randiset_fn: POINTER)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct __anonstruct_gmp_randfnptr_t_11 *)$a_c_pointer)->randiset_fn = $a_randiset_fn;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmpz.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "randseed_fn") == 0) return offsetof(struct __anonstruct_gmp_randfnptr_t_11, randseed_fn);
				if(strcmp($a_field_name, "randget_fn") == 0) return offsetof(struct __anonstruct_gmp_randfnptr_t_11, randget_fn);
				if(strcmp($a_field_name, "randclear_fn") == 0) return offsetof(struct __anonstruct_gmp_randfnptr_t_11, randclear_fn);
				if(strcmp($a_field_name, "randiset_fn") == 0) return offsetof(struct __anonstruct_gmp_randfnptr_t_11, randiset_fn);
				fprintf(stderr, "struct __anonstruct_gmp_randfnptr_t_11.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
