class
	PD_MPQ_STRUCT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_mp_num: PD_MPZ_STRUCT
				a_mp_den: PD_MPZ_STRUCT
			])
		require else
			a_data /= Void
		do
			make
			mp_num.c_pointer.memory_copy (a_data.a_mp_num.c_pointer, a_data.a_mp_num.structure_size)
			mp_den.c_pointer.memory_copy (a_data.a_mp_den.c_pointer, a_data.a_mp_den.structure_size)
		end

feature {ANY} -- fields

	mp_num: PD_MPZ_STRUCT assign set_mp_num
		once ("OBJECT")
			create Result.make_shared (c__mp_num (internal_c_pointer))
		end

	mp_den: PD_MPZ_STRUCT assign set_mp_den
		once ("OBJECT")
			create Result.make_shared (c__mp_den (internal_c_pointer))
		end

feature {ANY} -- field setters

	set_mp_num (a_mp_num: PD_MPZ_STRUCT)
		do
			c__set_mp_num (internal_c_pointer, a_mp_num.c_pointer)
		end

	set_mp_den (a_mp_den: PD_MPZ_STRUCT)
		do
			c__set_mp_den (internal_c_pointer, a_mp_den.c_pointer)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return sizeof(struct __anonstruct___mpq_struct_2);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return __alignof__(struct __anonstruct___mpq_struct_2);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__mp_num (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmpz.h%""
		alias
			"return (EIF_POINTER)&((struct __anonstruct___mpq_struct_2 *)$a_c_pointer)->_mp_num;"
		end

	c__mp_den (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmpz.h%""
		alias
			"return (EIF_POINTER)&((struct __anonstruct___mpq_struct_2 *)$a_c_pointer)->_mp_den;"
		end

	c__set_mp_num (a_c_pointer: POINTER; a_mp_num: POINTER)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct __anonstruct___mpq_struct_2 *)$a_c_pointer)->_mp_num = *(struct __anonstruct___mpz_struct_1 *)$a_mp_num;"
		end

	c__set_mp_den (a_c_pointer: POINTER; a_mp_den: POINTER)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct __anonstruct___mpq_struct_2 *)$a_c_pointer)->_mp_den = *(struct __anonstruct___mpz_struct_1 *)$a_mp_den;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmpz.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "mp_num") == 0) return offsetof(struct __anonstruct___mpq_struct_2, _mp_num);
				if(strcmp($a_field_name, "mp_den") == 0) return offsetof(struct __anonstruct___mpq_struct_2, _mp_den);
				fprintf(stderr, "struct __anonstruct___mpq_struct_2.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
