#ifndef LIBMPZ_H
#define LIBMPZ_H

#include <ffi.h>
#include <stdio.h>
#include <inttypes.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#undef _mp_alloc
#undef _mp_size
#undef _mp_d
#undef _mp_num
#undef _mp_den
#undef next
#undef size
#undef manl
#undef manh
#undef exp
#undef sig
#undef s
#undef d
#undef chars_per_limb
#undef chars_per_bit_exactly
#undef big_base
#undef big_base_inverted
#undef _ptr
#undef _cnt
#undef _base
#undef _flag
#undef _file
#undef _charbuf
#undef _bufsiz
#undef _tmpfname
#undef _mp_lc
#undef _mp_seed
#undef _mp_alg
#undef _mp_algdata
#undef randseed_fn
#undef randget_fn
#undef randclear_fn
#undef randiset_fn
#undef _mp_prec
#undef _mp_exp
#undef __builtin_expect
#undef __gmpq_set
#undef __gmpn_add_n
#undef __gmpn_perfect_square_p
#undef __gmpn_popcount
#undef __gmpn_sub_n
#undef __gmpn_copyi
#undef __gmpn_mul
#undef __gmp_tmp_reentrant_alloc
#undef __gmp_tmp_reentrant_free
#undef __gmpn_addmul_1
#undef __gmpn_mul_1
#undef __gmpn_submul_1
#undef __gmpn_divexact_1
#undef __gmpn_divrem_1
#undef __gmp_divide_by_zero
#undef __gmpn_mod_1
#undef __gmpn_rshift
#undef _vsnprintf
#undef _Dest
#undef _Count
#undef _Format
#undef _Args
#undef _vsnwprintf
#undef __gmp_extract_double
#undef __gmp_invalid_operation
#undef __builtin_clzl
#undef __builtin_ctzl
#undef __gmpn_divisible_p
#undef __gmpn_modexact_1c_odd
#undef __gmpn_divexact
#undef __gmpn_bdiv_dbm1c
#undef __gmpn_modexact_1_odd
#undef strlen
#undef _Str
#undef _stricmp
#undef _Str1
#undef _Str2
#undef _strnicmp
#undef _MaxCount
#undef __gmpn_lshift
#undef __gmpn_fib2_ui
#undef __gmpn_gcd
#undef __gmpn_gcd_1
#undef __gmpn_gcdext
#undef __gmpn_get_d
#undef __gmpn_get_str
#undef __gmpn_hamdist
#undef _exit
#undef _Code
#undef abort
#undef _i64toa
#undef _Val
#undef _DstBuf
#undef _Radix
#undef _ui64toa
#undef _atoi64
#undef _String
#undef _i64tow
#undef _ui64tow
#undef _wtoi64
#undef fprintf
#undef _File
#undef fread
#undef _ElementSize
#undef getc
#undef ungetc
#undef _Ch
#undef isspace
#undef _C
#undef __gmpn_set_str
#undef __gmpn_tdiv_qr
#undef __gmpn_jacobi_base
#undef __gmpn_sqr
#undef __gmp_randinit_default
#undef __gmp_randclear
#undef __gmpn_copyd
#undef fwrite
#undef _Size
#undef __gmp_assert_fail
#undef ferror
#undef fputc
#undef __gmpn_perfect_power_p
#undef __gmpn_mullo_n
#undef __gmpn_binvert
#undef __gmpn_binvert_itch
#undef __gmpn_powm
#undef __gmpn_powlo
#undef __gmpn_powm_sec
#undef __gmpn_powm_sec_itch
#undef __gmpn_preinv_mod_1
#undef __gmp_randinit_mt_noseed
#undef __gmpn_random2
#undef __gmpn_rootrem
#undef __gmp_sqrt_of_negative
#undef __gmpn_sqrtrem
#undef __gmpn_div_q

enum PC_gmp_randalg_t {
	GMP_RAND_ALG_DEFAULT = 0,
	GMP_RAND_ALG_LC = 0
};

struct __anonstruct___mpz_struct_1;
struct __anonstruct___mpq_struct_2;
struct tmp_reentrant_t;
struct __anonstruct_s_13;
union ieee_double_extract;
struct bases;
union __anonunion__mp_algdata_6;
struct __anonstruct___gmp_randstate_struct_5;
struct __anonstruct_gmp_randfnptr_t_11;
struct __anonstruct___mpf_struct_3;

typedef struct __anonstruct___mpz_struct_1 __mpz_struct;
typedef struct __anonstruct___mpq_struct_2 __mpq_struct;
typedef struct __anonstruct___gmp_randstate_struct_5 __gmp_randstate_struct;
typedef struct __anonstruct_gmp_randfnptr_t_11 gmp_randfnptr_t;
typedef struct __anonstruct___mpf_struct_3 __mpf_struct;

struct __anonstruct___mpz_struct_1 {
	int _mp_alloc;
	int _mp_size;
	unsigned long * _mp_d;
};
struct __anonstruct___mpq_struct_2 {
	__mpz_struct _mp_num;
	__mpz_struct _mp_den;
};
struct tmp_reentrant_t {
	struct tmp_reentrant_t * next;
	unsigned int size;
};
struct __anonstruct_s_13 {
	unsigned int manl : 32;
	unsigned int manh : 20;
	unsigned int exp : 11;
	unsigned int sig : 1;
};
union ieee_double_extract {
	struct __anonstruct_s_13 s;
	double d;
};
struct bases {
	int chars_per_limb;
	double chars_per_bit_exactly;
	unsigned long big_base;
	unsigned long big_base_inverted;
};
union __anonunion__mp_algdata_6 {
	void * _mp_lc;
};
struct __anonstruct___gmp_randstate_struct_5 {
	__mpz_struct _mp_seed[1];
	unsigned int _mp_alg;
	union __anonunion__mp_algdata_6 _mp_algdata;
};
struct __anonstruct_gmp_randfnptr_t_11 {
	void( * randseed_fn)(__gmp_randstate_struct *, __mpz_struct *);
	void( * randget_fn)(__gmp_randstate_struct *, unsigned long *, unsigned long);
	void( * randclear_fn)(__gmp_randstate_struct *);
	void( * randiset_fn)(__gmp_randstate_struct *, __gmp_randstate_struct *);
};
struct __anonstruct___mpf_struct_3 {
	int _mp_prec;
	int _mp_size;
	long _mp_exp;
	unsigned long * _mp_d;
};

extern void __gmpq_set(__mpq_struct *, __mpq_struct *);
extern unsigned long __gmpn_add_n(unsigned long *, unsigned long *, unsigned long *, long);
extern int __gmpn_perfect_square_p(unsigned long *, long);
extern unsigned long __gmpn_popcount(unsigned long *, long);
extern unsigned long __gmpn_sub_n(unsigned long *, unsigned long *, unsigned long *, long);
extern void __gmpn_copyi(unsigned long *, unsigned long *, long);
extern unsigned long __gmpn_mul(unsigned long *, unsigned long *, long, unsigned long *, long);
extern void * __gmp_tmp_reentrant_alloc(struct tmp_reentrant_t * *, unsigned int);
extern void __gmp_tmp_reentrant_free(struct tmp_reentrant_t *);
extern unsigned long __gmpn_addmul_1(unsigned long *, unsigned long *, long, unsigned long);
extern unsigned long __gmpn_mul_1(unsigned long *, unsigned long *, long, unsigned long);
extern unsigned long __gmpn_submul_1(unsigned long *, unsigned long *, long, unsigned long);
extern void *( * __gmp_allocate_func)(unsigned int);
extern void __gmpn_divexact_1(unsigned long *, unsigned long *, long, unsigned long);
extern void *( * __gmp_reallocate_func)(void *, unsigned int, unsigned int);
extern unsigned long __gmpn_divrem_1(unsigned long *, long, unsigned long *, long, unsigned long);
extern void __gmp_divide_by_zero();
extern unsigned long __gmpn_mod_1(unsigned long *, long, unsigned long);
extern unsigned long __gmpn_rshift(unsigned long *, unsigned long *, long, unsigned int);
extern void( * __gmp_free_func)(void *, unsigned int);
extern int __gmp_extract_double(unsigned long *, double);
extern void __gmp_invalid_operation();
extern int __gmpn_divisible_p(unsigned long *, long, unsigned long *, long);
extern unsigned long __gmpn_modexact_1c_odd(unsigned long *, long, unsigned long, unsigned long);
extern void __gmpn_divexact(unsigned long *, unsigned long *, long, unsigned long *, long);
extern unsigned long __gmpn_bdiv_dbm1c(unsigned long *, unsigned long *, long, unsigned long, unsigned long);
extern unsigned long __gmpn_modexact_1_odd(unsigned long *, long, unsigned long);
extern unsigned long __gmpn_lshift(unsigned long *, unsigned long *, long, unsigned int);
extern long __gmpn_fib2_ui(unsigned long *, unsigned long *, unsigned long);
extern unsigned long __gmp_fib_table[];
extern long __gmpn_gcd(unsigned long *, unsigned long *, long, unsigned long *, long);
extern unsigned long __gmpn_gcd_1(unsigned long *, long, unsigned long);
extern long __gmpn_gcdext(unsigned long *, unsigned long *, long *, unsigned long *, long, unsigned long *, long);
extern double __gmpn_get_d(unsigned long *, long, long, long);
extern unsigned int __gmpn_get_str(unsigned char *, int, unsigned long *, long);
extern struct bases const __gmpn_bases[257];
extern unsigned long __gmpn_hamdist(unsigned long *, unsigned long *, long);
extern long __gmpn_set_str(unsigned long *, unsigned char const *, unsigned int, int);
extern unsigned char const __gmp_digit_value_tab[];
extern void __gmpn_tdiv_qr(unsigned long *, unsigned long *, long, unsigned long *, long, unsigned long *, long);
extern int __gmpn_jacobi_base(unsigned long, unsigned long, int);
extern void __gmpn_sqr(unsigned long *, unsigned long *, long);
extern void __gmp_randinit_default(__gmp_randstate_struct *);
extern void __gmp_randclear(__gmp_randstate_struct *);
extern void __gmpn_copyd(unsigned long *, unsigned long *, long);
extern void __gmp_assert_fail(char const *, int, char const *);
extern int __gmpn_perfect_power_p(unsigned long *, long);
extern void __gmpn_mullo_n(unsigned long *, unsigned long *, unsigned long *, long);
extern void __gmpn_binvert(unsigned long *, unsigned long *, long, unsigned long *);
extern long __gmpn_binvert_itch(long);
extern void __gmpn_powm(unsigned long *, unsigned long *, long, unsigned long *, long, unsigned long *, long, unsigned long *);
extern void __gmpn_powlo(unsigned long *, unsigned long *, unsigned long *, long, long, unsigned long *);
extern void __gmpn_powm_sec(unsigned long *, unsigned long *, long, unsigned long *, long, unsigned long *, long, unsigned long *);
extern long __gmpn_powm_sec_itch(long, long, long);
extern unsigned long __gmpn_preinv_mod_1(unsigned long *, long, unsigned long, unsigned long);
extern void __gmp_randinit_mt_noseed(__gmp_randstate_struct *);
extern char __gmp_rands_initialized;
extern __gmp_randstate_struct __gmp_rands[1];
extern void __gmpn_random2(unsigned long *, long);
extern long __gmpn_rootrem(unsigned long *, unsigned long *, unsigned long *, long, unsigned long);
extern void __gmp_sqrt_of_negative();
extern long __gmpn_sqrtrem(unsigned long *, unsigned long *, unsigned long *, long);
extern void __gmpn_div_q(unsigned long *, unsigned long *, long, unsigned long *, long, unsigned long *);

#endif
