class
	S_STDIO_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	fread (a_ptr: CE_POINTER [ANY]; a_size, a_n: NATURAL_32; a_stream: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fread (a_ptr.c_pointer, a_size, a_n, a_stream.c_pointer)
		end

	c_fread (a_ptr: POINTER; a_size: NATURAL_32; a_n: NATURAL_32; a_stream: POINTER): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return fread($a_ptr, $a_size, $a_n, $a_stream);"
		end

	getc (a_file: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_getc (a_file.c_pointer)
		end

	c_getc (a_file: POINTER): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return getc($a_file);"
		end

	ungetc (a_c: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_ungetc (a_c, a_stream.c_pointer)
		end

	c_ungetc (a_c: INTEGER_32; a_stream: POINTER): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return ungetc($a_c, $a_stream);"
		end

	fwrite (a_ptr: CE_POINTER [ANY]; a_size, a_n: NATURAL_32; a_s: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fwrite (a_ptr.c_pointer, a_size, a_n, a_s.c_pointer)
		end

	c_fwrite (a_ptr: POINTER; a_size: NATURAL_32; a_n: NATURAL_32; a_s: POINTER): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return fwrite($a_ptr, $a_size, $a_n, $a_s);"
		end

	fputc (a_c: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputc (a_c, a_stream.c_pointer)
		end

	c_fputc (a_c: INTEGER_32; a_stream: POINTER): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return fputc($a_c, $a_stream);"
		end

	ferror (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_ferror (a_stream.c_pointer)
		end

	c_ferror (a_stream: POINTER): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return ferror($a_stream);"
		end

end
